#ifndef __CertStore__
#define __CertStore__

#include <windows.h>

class cCertStore
{
	void *hSystemStore;              // The system store handle.
public:
	// Enum store type.
	enum{ estRoot = 0, estTrust, estMy, estCA };

	// Errors
	enum{ errOK = 0, errInvalidStore, errCertificateNotFound, errCertificateWasNotAdded };

	cCertStore( int storeType = estRoot );
	~cCertStore( );
	int findCertificateByDN(
		BYTE **pPtr,	// pointer to found cetificate buffer in store.
		int *pSize,		// pointer to size of found certificate
		BYTE *dn,		// Distinguished Name buffer
		int dnSize		// size od DN buffer.
		);

//	int findCertificateByAthorityKeyID();

	int addCertificateToStore(
		BYTE *crtBuff,	// ASN.1 encoded certificate buffer.
		int size		// Size of certificate buffer.
		);
};

int verifyX509Certificate( BYTE *ptr, int size );

#endif // __CertStore__