/**
 *
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	file: container.h
 *	scope: v8 format
 *	author: evgeny yakovlev
 *
 *	description: 
 *	Definition of container-related interfaces.
 *
 *	history:
 *
 */

#ifndef V8_CONTAINER_H
#define V8_CONTAINER_H

#include <stdlib.h>
#include <string.h>

#include "datablock.h"
#include "kgghost.h"

#include <common/build.h>
#include <common/types.h>

#include <alg/alg.h>

#include <container/format.h>
#include <container/factory.h>


namespace raw
{

	/**
	 * @brief 	v8 format adaptor
	 */
	class RawFormat : public bdk::IBCContainerFormat
	{
	public:


		RawFormat()
		{};


		BC_INHERITED	std::string name() const
		{
			return "raw";
		}


        	BC_INHERITED 	bc_ulong_t size_bytes () const
		{
		}


		BC_INHERITED	void set_size_bytes(bc_ulong_t size)
		{
		}


       		BC_INHERITED 	std::string description () const
		{
       
		}

                
		BC_INHERITED	void set_description(std::string const & desc)
		{
		}


       		BC_INHERITED 	bc_alg_id_t algorithm_id () const
		{
       		}


		BC_INHERITED 	void set_algorithm_id(bc_alg_id_t id)
		{
       		}
		

		BC_INHERITED 	bc_alg_mode_id_t algorithm_mode_id() const
		{
		}


		BC_INHERITED 	void set_algorithm_mode_id(bc_alg_mode_id_t mod)
		{
		}


        	BC_INHERITED 	bc_fs_id_t fs_id () const
		{
		}


		BC_INHERITED 	void set_fs_id(bc_fs_id_t id)
		{
		}


	        BC_INHERITED 	bool is_locked () const
		{
		}


		BC_INHERITED 	void lock()
		{
		}


		BC_INHERITED 	void unlock()	
		{
		}
	

		BC_INHERITED	void serialize(bdk::IBCContainerIO* dest) const
		{
		}


		BC_INHERITED	bdk::BCContainerViewHandle create_view(bdk::IBCContainerIO* io)
		{
			return bdk::BCContainerView::invalid_view();
		}


		BC_INHERITED	bdk::BCContainerViewHandle create_hidden_view(bdk::IBCContainerIO* io, bc_ulong_t size)
		{
			return bdk::BCContainerView::invalid_view();
		}


		BC_INHERITED 	bdk::BCContainerViewHandle get_view(bdk::IBCContainerIO* io);


		BC_INHERITED	bdk::BCContainerViewHandle update_view(bdk::IBCContainerIO* io, bdk::bc_view_change_t op)
		{
			return bdk::BCContainerView::invalid_view();
		}


	private:
	};

}



#endif

