/**
 *
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	file: module.h
 *	scope: v8 format
 *	author: evgeny yakovlev
 *
 *	description: 
 *	history:
 *
 */


#ifndef V8_MODULE_H
#define V8_MODULE_H

#include <common/build.h>
#include <mod/delegate.h>


namespace kgghost
{
	class V8Factory;
}


namespace kgghost
{

	/**
	 * @brief 	V8 module delegate 
	 */
	class V8Module : public bdk::IBCModuleDelegate
	{
	public:

        	/**
	         * @brief 	Load hook
        	 */
		BC_INHERITED	bool on_load();


        	/**
	         * @brief 	Unload hook
        	 */
	        BC_INHERITED	bool on_release();


		/**
		 * @brief	Module name.
		 */
		BC_INHERITED	const char* name() const;


		/**
		 * @brief	Module id.
		 */
		BC_INHERITED	bc_mod_id_t id() const;

	
		/**
		 * @brief	Module description.
		 */
		BC_INHERITED	const char* description() const;


	private:


		V8Factory* 	m_my_factory;
	};

}



/**
 * @brief 	This will be called by core when it wants to access us
 */
extern "C" bdk::IBCModuleDelegate* bc_module_export();

#endif 
