#include <unistd.h>

#include "user.h"
#include "alg_utils.h" // ShredData
#include "kg_errors.h"
#include "CertificateLib/SMemory/cPassword.h"

#include <common/log.h>

namespace kgghost
{

	int User_GetPassword(const char* caption, cPassword& pwd, unsigned int* pFlags)
	{
    		char *pwdbuf;

		if ( !(pwdbuf = getpass (caption)) ) 
			return ERROR_INTERNAL_PROBLEM;

		
		pwd.Set(pwdbuf, strlen(pwdbuf));
		pwd.GenerateUnicodeString();
    		ShredData((bc_byte_t*)pwdbuf, strlen(pwdbuf));

		return ERROR_NO;
	}


	int User_GenerateSeed(char* seed, unsigned int seed_size)
	{
		using namespace bdk;

		FILE *fd;
    
    		if (! (fd=fopen("/dev/random","r"))) return ERROR_INTERNAL_PROBLEM;
		bc_get_log(BC_INFO).msg("generating random seed, randomly move your mouse or press keys to speed the process\n");
	
		unsigned int i = 0;
		do {
			bc_get_log(BC_INFO).msg("random seed generation: %d\\%d bits (%d%%) 		\r", (i+1)*8, seed_size*8, ((i+1)*100/seed_size));
	        	seed[i++]=(char)fgetc(fd);
		} while ( i < seed_size );

		bc_get_log(BC_INFO).msg("\n");
		fclose (fd);
		return ERROR_NO;
	}


	void User_Message(const char* text)
	{
		using namespace bdk;
		bc_get_log(BC_INFO).msg(text);
	}

}



