/*******************************************************************
 *
 *	Copyright (c) 1994-2008 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: user.h
 *	Revision: 
 *	Created:
 *	Description: KG-Ghost user interaction (seed, password, etc.)
 *
 *******************************************************************/

#ifndef V8_USER_H
#define V8_USER_H


class cPassword;

#define INCORRECT_PWD_STR "Incorrect password"
#define ENTER_PWD_STR "Enter password"
#define ENTER_ADDITIONAL_PWD_STR "Enter additional password"

namespace kgghost
{

	/**
	 * @brief	Ask user password
	 *
	 * @p caption	Invitation string
	 * @p pwd	Password object to initialize from user input
	 * @p pFlags	Advanced user interaction flags
	 */	
	int User_GetPassword(const char *caption, cPassword& pwd, unsigned int* pFlags);


	/**
	 * @brief	Generate random seed
	 *
	 * @p seed	Buffer
	 * @p seed_size	Buffer size
	 */
	int User_GenerateSeed(char* seed, unsigned int seed_size);


	/**
	 * @brief	Display a message for user.
	 */
	void User_Message(const char* msg);

} // namespace kgghost


#endif

