#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "kg_defs.h"

const char* sha_error_str (int error)
{

    switch ( error )
    {
        case ERROR_NO:
//            sprintf(err_str,"no errors\n");
            return NULL;
// Kgsha errors
        case ERROR_INTERNAL_PROBLEM:
            return "Internal problems";
        case ERROR_INVALID_ALGORITHM:
	    return "Invalid algorithm";
        case ERROR_INCORRECT_CREATE_FLAG:
	    return "Unsupported create flag";
        case ERROR_INCORRECT_FORMAT_VERSION:
	    return "Unsupported format version";
        case ERROR_INCORRECT_BLOCK_SIGNATURE:
	    return "Unsupported block signature";
        case ERROR_DAMAGED_DATA_BLOCK:
	    return "Damaged data block";
        case ERROR_CANCELLED_BY_USER:
	    return "Cancelled by user";
        case ERROR_USER_PASSWORDS_MISMATCH:
	    return "Password mismatch";
        case ERROR_INCORRECT_PASSWORD:
	    return "Password incorrect";
	case ERROR_MASTER_PASSWORD_ENTERED:
		return "Master password entered";
        case ERROR_NOT_ENOUGH_INIT_KEYS:
	    return "Not enough init keys";
        case ERROR_INCORRECT_ENCR_ALGORITHM:
	    return "Incorrect encryption algorithm";
        case ERROR_INCORRECT_HASH_ALGORITHM:
	    return "Incorrect hash algorithm";
        case ERROR_INCORRECT_DATA_BLOCK_SIZE:
	    return "Incorrect datablock size";
        case ERROR_NOT_ENOUGH_SPACE_FOR_KEY:
	    return "Not enough space for key";
        case ERROR_INCORRECT_POOL:
	    return "Incorrect pool";
        case ERROR_HID_PASSWORD_INVALID:
	    return "Cannot create hidden part.\nPlease try to mount container with this password";
	default:
	    return NULL;
/*
// Config errors
        case FATAL_ERROR:
            sprintf(err_str,"Config: Fatal error\n");break;
        case NO_MEM:
            sprintf(err_str,"Config: Not enough memory\n");break;
        case CONF_BAD_FNAME:
            sprintf(err_str,"Config: Cannot open config file\n");break;
        case CONF_FOPEN_ERR:
            sprintf(err_str,"Config: Error while opening config file\n");break;
        case CONF_BAD_FILE:
            sprintf(err_str,"Config: Bad config file\n");break;
        case TOKEN_FATAL:
            sprintf(err_str,"Config: Token fatal error\n");break;
        case TOKEN_TRUNC:
            sprintf(err_str,"Config: Token truncated\n");break;
        case TOKEN_BAD:
            sprintf(err_str,"Config: Bad token\n");break;
        case TOKEN_EMPTY:
            sprintf(err_str,"Config: Token empty\n");break;

        default:
            fprintf(stderr,"%s\n",strerror(-error));return;
    }
*/

//    fprintf(stderr,err_str);
    }
}

void print_error( int error )
{
	const char* msg = sha_error_str( error );
	if( msg ) {
		fprintf(stderr, "Key Generator: %s\n", msg);
	}
}

