/*******************************************************************
*
*      Copyright (c) 1994-1999 Jetico, Inc., Finland
*      All rights reserved.
*
*      File: bccreate.c
*      Revision: $Id: header.h,v 1.3 2002-10-29 07:11:31 crypt Exp $
*      Created:
*      Description: definition of container header structure
*
*******************************************************************/
 
#ifndef __HEADER_H__
#define __HEADER_H__

#include "wintypes.h"
#include <common/build.h>

BC_PACKED (
struct BPB
{
	WORD sectSize;
	BYTE sectPerCluster;
	WORD reservedSectors;
	BYTE NumberOfFat;
	WORD maxRootDirEntry;
	WORD totalSectors;
	BYTE mediaDesc;
	WORD sectorsPerFat;
	WORD sectorsPerTrack;
	WORD numberOfHeads;
	DWORD hiddenSectors;
	DWORD totalSectorsLong;
}
);

/**
 * @brief Boot record, 62 bytes
 */
BC_PACKED (
struct BootRecord 
{
	BYTE jmpCode[3];
	char OEMid[8];

	struct BPB bpb;
	BYTE driveNo; // 0, 80h
	BYTE reserved;
	BYTE extBootSign;
	DWORD serialNumber;
	char volumeLabel[11];
	char FatType[8];
}
);


#define HIDDEN_SECTOR_SIZE 	512
#define KEY_DATA_SIZE		4
#define DESCR_SIZE		66
#define SIG_SIZE 		8

BC_PACKED(
struct HiddenSector
{
	struct BootRecord br;
	char description[DESCR_SIZE];
	WORD extent;
	WORD version;
	BYTE keyData[KEY_DATA_SIZE];

	BYTE reserved[
		HIDDEN_SECTOR_SIZE -
		sizeof(struct BootRecord) -
		DESCR_SIZE * sizeof(char) - 
		sizeof(WORD) -  // sizeof(extent)-
		sizeof(WORD) -  // sizeof(version)-
		KEY_DATA_SIZE * sizeof(BYTE) -  // sizeof(keyData)-
		sizeof(DWORD) -	// dwKeySize
		sizeof(DWORD) -  // dwDataOffset
		sizeof(DWORD) -  // fileSystemId
		sizeof(DWORD) -  // algorithmId
		sizeof(DWORD) -	// keyGenId
		SIG_SIZE * sizeof(char) // signature
	];

	DWORD dwKeySize;	// Key size. Key is to be placed just after hidden sector in container...
	DWORD dwDataOffset;	// Encrypted Data offset from file begining in bytes...
	DWORD fileSystemId;	// Driver will mark container during formating formating...
	DWORD algorithmId;	// Encryption Algorithm identifier.  
	DWORD keyGenId;		// Key generation identifier...
	char signature[ SIG_SIZE ];
}
);


#endif /* __HEADER_H__ */

 

