/*******************************************************************
 *
 *	Copyright (c) 1994-1999 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: kg_misc.cc
 *	Revision:  $Id: kg_misc.cpp,v 1.1 2005-05-12 09:51:39 crypt Exp $
 *	Created:
 *	Description: implementation of miscelleneous procedures 
 *		to allocate, shredd and free some specific data
 *
 *******************************************************************/

#include <time.h>
#include <stdlib.h>
#include "kg_defs.h"
#include "kg_misc.h"
#include "sha_generic.h"


#include <common/types.h>

#define FALSE 0
#define TRUE 1
#define POOL_SIZE_BYTES 512

char kg_misc_cpp[]="$Id: kg_misc.cpp,v 1.1 2005-05-12 09:51:39 crypt Exp $";

BOOL Allocate( BYTE **seed, char **password, char **newPassword, BYTE **key, BYTE **pool )
{
	*seed = new BYTE[ SEED_LENGTH + 4];
	if (!seed) return FALSE;

	*key = new BYTE[ MAXIMUM_KEY_SIZE_BYTES + 4 ];
	if (!key)
	{	delete seed;
		return FALSE;
	}

	*password = new char[ PASSWORD_MAXIMUM_LENGTH + 4];
	if (!password)
	{	delete seed;
		delete key;
		return FALSE;
	}

	*newPassword = new char[ PASSWORD_MAXIMUM_LENGTH + 4];
	if (!newPassword)
	{	delete seed;
		delete key;
		delete password;
		return FALSE;
	}

	*pool = new BYTE[ POOL_SIZE_BYTES ];
	if (!pool)
	{	delete seed;
		delete key;
		delete password;
		delete newPassword;
		return FALSE;
	}
	return TRUE;
}


void Free( BYTE *seed, char *password, char *newPassword, BYTE *key, BYTE *pool )
{
	delete [] seed;
	delete [] key;
	delete [] password;
	delete [] newPassword;
	delete [] pool;
}


void ShredData( BYTE *data, int dataLength )
{	int i;

	if ((!data) || (dataLength <= 0)) return;
	srand( (unsigned int)time( NULL ) );
	for(i=0; i < dataLength; i++)
	{
		data[i] = (BYTE)rand();
	}
	
	RandomGenerate(SHA256_ID, data, dataLength, data, dataLength);
}


