/*******************************************************************
 *
 *	Copyright (c) 1994-1999 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: kgsha.h
 *	Revision:  $Id: kgsha.h,v 1.2 2006-11-07 06:29:13 nail Exp $
 *	Created:
 *	Description: main header file of the libkgsha with the 
 *		functions that may be called from external programs
 *
 *******************************************************************/

#ifndef MOD_SHA_KGHSA_H
#define MOD_SHA_KGSHA_H

#include "wintypes.h"

#include <common/build.h>
#include <alg/alg.h>


BOOL GetNameAndVersion( 
			char  *Name, 
			DWORD  nameSize, 
			DWORD *Major, 
			DWORD *Minor 
			);

BOOL CreateHandle(
		bdk::BCAlgHandle& handle,
		int algid,		
		DWORD	CreateFlag,	/* whether to create new key or open existing */
		BYTE	**vDataBlock,	/* block of data that is stored inside file-container in encrypted form */
		DWORD	*DataSize,	/* size of the block of data */
		int	*ErrorCode	/* if the function returns FALSE, look at the Error code */
		);


BOOL CreateHandleEx(
		bdk::BCAlgHandle& handle,
		int algid,
		DWORD	CreateFlag,		// whether to create new key or open existing
		BYTE	**vDataBlock,	// block of data that is stored inside file-container in encrypted form
		DWORD	*DataSize,		// size of the block of data
		int	*ErrorCode,		// if the function returns FALSE, look at the Error code
		DWORD	*DataOffset
		);


DWORD FreeDataBlock( BYTE **vDataBlock );

/*
DWORD FreeKeyHandle( 
		ALG_SERV Alg,
		DWORD KeyHandle 
		);
*/


#endif
/* __KGSHA__                  */
