#include <string.h>

#include "module.h"
#include "container.h"

#include <mod/manager.h>
#include <common/log.h>
#include <common/core.h>


using namespace bdk;


bool V7Module::on_load()
{
	m_my_factory = new V7Factory();
	
	std::string product(this->name());
	BC_DEBUG_PRINT(("Registering container type %s\n", product.c_str()));

	bc_core()->container_manager()->register_type(std::string(this->name()), m_my_factory, false);
	return true;
}


bool V7Module::on_release()
{
	bc_core()->container_manager()->unregister_type(std::string(this->name()));
	delete m_my_factory;
	return true;
}


const char* V7Module::name() const
{
	return "BCv7";
}


bc_mod_id_t V7Module::id() const
{
	return KGSHA256_ID;
}


const char* V7Module::description() const
{
	return "BC Container Format V7 (SHA\\SHA256 keygen)";
}


BC_EXPORT_MODULE(V7Module)

