#ifndef BC_MOD_SHA_EXPORT_H
#define BC_MOD_SHA_EXPORT_H

#include <common/build.h>
#include <mod/delegate.h>
#include "sha_generic.h"


class V7Factory;

/**
 * @brief 	V7 module delegate 
 */
class V7Module : public bdk::IBCModuleDelegate
{
public:

        /**
         * @brief 	Load hook
         */
	BC_INHERITED	bool on_load();


        /**
         * @brief 	Unload hook
         */
        BC_INHERITED	bool on_release();


	/**
	 * @brief	Module name.
	 */
	BC_INHERITED	const char* name() const;


	/**
	 * @brief	Module id.
	 */
	BC_INHERITED	bc_mod_id_t id() const;

	
	/**
	 * @brief	Module description.
	 */
	BC_INHERITED	const char* description() const;


private:

	V7Factory* 	m_my_factory;


};



/**
 * @brief 	This will be called by core when it wants to access us
 */
extern "C" bdk::IBCModuleDelegate* bc_module_export();


#endif 
