/*
 *      Generic sha interface for common code
 *      Implemented by SHA-1 and SHA-256 keygens
 */

#ifndef BC_MOD_SHA_GENERIC_H
#define BC_MOD_SHA_GENERIC_H

#include "wintypes.h"

#define SHA_ID  	0x53484131
#define SHA256_ID 	0x53323536

/**
 * @brief	Get specific SHA-family digest size
 */
DWORD DigestSize(DWORD hashAlgId);


/**
 * @brief	Calculate SHA-family digest
 */
BOOL CalculateDigest( DWORD hashAlgId, BYTE *Data, DWORD Length, BYTE *Digest );


/**
 * @brief	Utilize SHA-family hash algs to generate random bytes
 */
BOOL RandomGenerate(DWORD hashAlgId, BYTE* byteBuffer, DWORD byteBufferSize, BYTE* seedBuffer, DWORD seedBufferSize );


#endif
