#ifndef __CLIENT__
#define __CLIENT__

/*******************************************************************
 *
 *	Copyright (c) 1994-2000 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File:        client.h
 *	Revision:  
 *	Created:     23-June-2000
 *  Author:      Sergey A. Frolov
 *	Description: performs connection with BCServer process on remote
 *		computer to save encryption keys, mount containers that are 
 *		allowed by Administrator for opening by the user
 *
 *******************************************************************/

#include <windows.h>

#define RIGHT_DO_NOT_GIVE_KEY_TO_ADMIN 0x00000001
#define RIGHT_TO_REENCRYPT_CONTAINER   0x00000002

struct sKeyInfo;

// Client_CheckBcServerExistance() checks if BCServer exists and returns 
// Name of Computer where BCServer is running
extern BOOL Client_CheckBcServerExistance();

// Client_CheckIfUserRegisteredOnServer() checks if the user is registered 
// in BCServer's database. If not, it suggests to register.
//
// Registering means that user creates public/private keys, then encrypts
// private key by own password and place the pair to the BCServer's database
extern BOOL Client_CheckIfUserRegisteredOnServer( HWND hWndParent, char *NetworkPassword, DWORD *Rights );

extern BOOL Client_GetUserRights( DWORD *Rights );

extern BOOL Client_GetKeyForContainer( BYTE *ContainerId, sKeyInfo *keyInfo, const char *Password );

extern BOOL Client_GetUserRights(
		const char *UserName, // if user_name is empty ("\0"), default rights are returned
		DWORD      *DefaultRights, 
		DWORD      *UserRights 
	);

extern BOOL Client_EncryptAndSaveKeyOnBCServer(
		sKeyInfo *keyInfo, 
		const wchar_t *ContainerPath, 
		BYTE *ContainerId,
		DWORD Rights
	);

extern BOOL Client_RemoveContainerFromBCServer( const wchar_t *ContainerPath, BYTE *ContainerId );

#endif // __CLIENT__
