/*******************************************************************
 *
 *	Copyright (c) 1994-2000 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: commands.h
 *	Revision: 
 *	Created:
 *	Description: the file declares class to add and call 
 *  additional commands for Key Generator
 *
 *******************************************************************/

#ifndef __COMMANDS
#define __COMMANDS

#include <windows.h>

#define MAX_COMMAND_NAME_LENGTH 128
#define MAX_NUMBER_OF_COMMANDS  16

typedef BOOL CommandFunction( 
		wchar_t *ContainerPath,
		BYTE    *DataBlock,
		int     DataBlockSize,
		void   *params           // see the kg_defs.h file
		);

class CCommands
{
// Operations
public:

	CCommands();

	BOOL AddCommand( 
		UINT uID,                   // resource identifier
		CommandFunction *Function    // correspondent additional function
		);

	DWORD GetCommandsBuffer( wchar_t *Buffer, int *BufferSize ); // returns Error Code, see kg_defs.h

	int GetCommandsNumber() { return m_commandsNumber; }
	
	BOOL RunCommand( 
		wchar_t	*CommandName,   
		wchar_t	*ContainerPath,
		BYTE    *DataBlock,
		int     DataBlockSize,
		void   *params           // see the kg_defs.h file
		);

private:

	HMODULE            m_hModule;
	int                m_idsTable[ MAX_NUMBER_OF_COMMANDS ];
	CommandFunction   *m_commands[ MAX_NUMBER_OF_COMMANDS ];
	wchar_t           *m_refTable[ MAX_NUMBER_OF_COMMANDS ];
	int                m_commandsNumber;
	wchar_t            m_buffer[ 256 ];
	int                m_nextCmdOffset;

};


int bytes2string( char *str, int strSize, BYTE *bf, int bfSize );
int bytes2string( wchar_t *str, int strSize, BYTE *bf, int bfSize );

#endif /* __COMMANDS */
