#ifndef V8_PKE_PROCESSOR_H
#define V8_PKE_PROCESSOR_H

#include "keyblock.h"

namespace kgghost
{


	/**
	 * @brief	Public Key Encryption key block processor
	 */
	class CPKEProcessor : public IKeyBlockProcessor
	{
	public:


		/**
		 * @brief	Decode PKE key block into encryption key
		 */
		BC_INHERITED	bool decode(const bc_byte_t* kbEncrypted, unsigned int & kbSize, key_info_t& key, cPassword const & init_pwd);


		/**
		 * @brief	Encode encryption key into PKE block
		 */
		BC_INHERITED 	bool encode(bc_byte_t* kbEncrypted, unsigned int & kbSize, key_info_t const & key, cPassword const & init_pwd);


		BC_INHERITED	~CPKEProcessor();


	};

} // namespace kgghost

#endif
