/*******************************************************************
 *
 *	Copyright (c) 1994-2005 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: pwdlg.cpp
 *	Revision: 
 *	Created:
 *	Description: implementation of procedures that support 
 *		dialog boxes for accepting user's password and 
 *		dialog that supports generation of seed value for 
 *		random key generation
 *
 *******************************************************************/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <shlobj.h>
#include <stdio.h>

#include "..\..\comm_def\dllMain.h"
#include "KBlock.h"
#include "..\..\Comm_def\Kg_defs.h"
#include "resource.h" 
#include "pwdlg.h"
#include "..\..\COMM_DEF\kbd.h"
#include "diskDriver.h" // For CmdGetVDiskMask, see description of _GetLogicalDrives()...
#include "..\..\COMM_DEF\UnicodeFuncs.h"
#include "cDlgKbParams.h"

//#define MSG_SEED_READY		(WM_USER + 0x529)

//typedef BOOL CALLBACK DlgProcType( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

/* Forward declarations of local procedures */

//BOOL CALLBACK getPasswordVerifyDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
//BOOL CALLBACK getPasswordDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
//BOOL CALLBACK getPasswordDlgProcSimple( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
//BOOL CALLBACK getRandomDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
//BOOL CALLBACK getAdvancedFlagsDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
//BOOL UpdateSeed( BYTE *Seed );
//BOOL convertTextToFilenamePath( LPCSTR Text );
//static DWORD _GetLogicalDrives();


/* Global data */

//#define BUFFER_SIZE 1024
//
//// The problem with **** ||||| in password dialog is fixed 
//// by changing font name in resource file.
//const char *szPwdFontName = "MS Shell Dlg";
//const bool changeFont = false;

//const wchar_t *Caption;
//
//wchar_t *Password;
//wchar_t *Buffer, *BufferB;
//wchar_t FileName[ MAX_PATH ];
//wchar_t PathName[ MAX_PATH ];
//wchar_t NotFileName[ MAX_PATH * 2 ];

//
// See kbdParams structtre in KBD.H
//
//UINT   *VkOriginal,   *VkMessed;
//USHORT *ScodOriginal, *ScodMessed;
//BYTE   *ShiftTable;
//UINT   TableSizeNL, TableSizeSm, ShiftTableSize;
//
//
//DWORD  KeyGenFlags;
//DWORD  KeyGenFavoriteDrive;
//
//BOOL   UseSecureTyping;
//bool   headerIsEncrypted;
//wchar_t *wcMountPoint = NULL;
//int posBrowseForMountPoint = -1;
//
//LONG_PTR wpOrigWndProc		= NULL;
////LONG_PTR wpEditOrigWndProc	= NULL;
//LONG_PTR wpEditOrigWndProcA = NULL;
//LONG_PTR wpEditOrigWndProcB	= NULL;

//DWORD GetPassword( 
//		HWND			hWndParent,
//		const wchar_t	*text,		// Text, containing filename of the container
//		const wchar_t	*caption,	// Caption of the "get password" dialog window
//		wchar_t			*password, 
//		DWORD			*Flags,
////		DWORD			*FavoriteDrive,
//		BOOL			ContainsFileName,
//		bool			*pIsEncrypted,
//		wchar_t			*mountPoint
//	)
//{
//	int result;
//
//	wcMountPoint = mountPoint;
//
//	Password = password;
//	Caption  = caption;
//	FileName[0] = '\0';
//	PathName[0] = '\0';
//
//	if ( getPasswordFromCommandLine( password, Flags, mountPoint ))
//	{
//		return ERROR_NO;
//	}
//	
//	if (ContainsFileName) // convertTextToFilenamePath( text );
//		convertTextToFilenamePath( FileName, PathName, text );
//	else
//	{
//		wcsncpy( NotFileName, text, maxLen( NotFileName ) );
//		FileName[0] = L'\0';
//		PathName[0] = L'\0';
//	}
//
//	Buffer = new wchar_t[ BUFFER_SIZE ];
//	if (!Buffer) return ERROR_INTERNAL_PROBLEM;
//	Buffer[0] = 0;
//
//	if (Flags) KeyGenFlags  = *Flags;
//
//	if ((KeyGenFlags & FLAG_ADVANCED_SECURE_TYPING) > 0)
//			UseSecureTyping = TRUE;
//	else	UseSecureTyping = FALSE;
//
//	if (FavoriteDrive) KeyGenFavoriteDrive = *FavoriteDrive;
//	else               KeyGenFavoriteDrive = 0xffff;
//
//	if ( ( KeyGenFavoriteDrive <= 26 ) || ( wcMountPoint != NULL ) )
//	{
//		if ( pIsEncrypted != NULL )
//			headerIsEncrypted = *pIsEncrypted;
//		else
//			headerIsEncrypted = false;
//
//		result = DialogBox( hMainInst, MAKEINTRESOURCE(IDD_PasswdDlg), 
//								hWndParent, (DLGPROC)getPasswordDlgProc );
//		if ( pIsEncrypted != NULL )
//			*pIsEncrypted = headerIsEncrypted;
//	}
//	else
//	{
//		result = DialogBox( hMainInst, MAKEINTRESOURCE(IDD_PasswdDlgSimple), 
//							hWndParent, (DLGPROC)getPasswordDlgProcSimple );
//	}
//
//	memset( Buffer, 0, BUFFER_SIZE * sizeof( wchar_t ));
//	delete Buffer;
//
//	if (result == -1) // system error 
//		return ERROR_INTERNAL_PROBLEM;
//
//	if (Flags) *Flags  = KeyGenFlags;
//
//	if (FavoriteDrive) *FavoriteDrive = KeyGenFavoriteDrive;
//	
//	return (DWORD)result;
//}

//DWORD GetPasswordWithVerification(
//		HWND   hWndParent,
//		const wchar_t	*text,		// Text, containing filename of the container
//		const wchar_t	*caption,	// Caption of the "get password" dialog window
//		wchar_t   *password,
//		DWORD  *pFlags
//	)
//{
//	int result;
//
//	Password = password;
//	Caption = caption;
//	convertTextToFilenamePath( FileName, PathName, text );
//
//	KeyGenFlags  = *pFlags;
//	if ((KeyGenFlags & FLAG_ADVANCED_SECURE_TYPING) > 0)
//			UseSecureTyping = TRUE;
//	else	UseSecureTyping = FALSE;
//	
//	Buffer  = new wchar_t[ BUFFER_SIZE ];
//	BufferB = new wchar_t[ BUFFER_SIZE ];
//
//	if (!Buffer) return ERROR_INTERNAL_PROBLEM;
//	if (!BufferB)
//	{
//		delete Buffer;
//		return ERROR_INTERNAL_PROBLEM;
//	}
//	Buffer[0]  = 0;
//	BufferB[0] = 0;
//
//	result = DialogBox( hMainInst, MAKEINTRESOURCE(IDD_PasswdDlgV), 
//						hWndParent, (DLGPROC)getPasswordVerifyDlgProc );
//
//	memset( Buffer,  0, BUFFER_SIZE * sizeof(Buffer[0]) );
//	memset( BufferB, 0, BUFFER_SIZE * sizeof(BufferB[0]) );
//
//	delete Buffer;
//	delete BufferB;
//
//	if (result == -1) // system error
//		return ERROR_INTERNAL_PROBLEM;
//
//	return (DWORD)result;
//}

// Local procedures 
//
//void insertCharToPwdBuffer( HWND Hwnd, char Letter, char *Buffer, size_t bufferSize, BOOL IsLetter )
//{
//   WORD caretPos, pwdLength, i, j;
// 
//   // Send the EM_GETSEL message to the edit control.
//   // The low-order word of the return value is the character
//   // position of the caret relative to the first character in the
//   // edit control.
//   caretPos = LOWORD((DWORD)SendMessage(Hwnd, EM_GETSEL, 0, 0L));
//
//   if ( caretPos >= bufferSize )
//	   return;
//
//   // caretPos is numbered from 1, so we have to decrement it
//   if ((Letter != 8) && ((Letter != 46) || IsLetter)) caretPos--;
//
//   pwdLength = (WORD)SendMessage(Hwnd, EM_LINELENGTH, (WPARAM)0, (LPARAM) 0); 
//   if ( pwdLength >= bufferSize )
//	   return;
//   
//   // Check if Letter is the BACKSPACE key
//   if (Letter == 8)
//   {
//		for (i=pwdLength-caretPos, j=caretPos; i; i--, j++)
//		{
//			Buffer[j] = Buffer[j+1];
//		}
//   }
//
//   // Check if Letter is the DELETE key
//   else if ((Letter == 46) && (!IsLetter)) 
//   {
//		if (caretPos < pwdLength)
//		{
//			for (i=pwdLength-caretPos, j=caretPos; i; i--, j++)
//			{
//				Buffer[j] = Buffer[j+1];
//			}
//		}
//   }
//   else
//   {
//		if (((caretPos + 1) != pwdLength) && (pwdLength > 0))
//		{
//			for( i=pwdLength-1; i>caretPos; i--)
//			Buffer[i] = Buffer[i-1];
//		}
//		Buffer[caretPos] = Letter;
//   }
//
//   Buffer[pwdLength] = 0;
//}
//
// Subclass procedure
//
//LRESULT APIENTRY editSubclassProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//	char    letter;
//	LRESULT lpRes;
//	BOOL    charAdded, isLetter;
//
//	charAdded = isLetter = FALSE;
//
//	kbdParams *kbd = kbdParams::GetParams( GetParent(hwnd) );
//	if ( kbd == NULL ) return 0;
//
//	switch (uMsg)
//	{
//		case WM_SETFOCUS:
//			if (!kbd->SetEncodingTable( UseSecureTyping ))
//			{	// send NULL string to delete all tables, because problems occured 
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//				UseSecureTyping = false;
//				MessageBox( GetParent(hwnd), "Error in settiing encoding table", "KeyGen - editSubclassProc", MB_ICONSTOP );
//				EndDialog( GetParent(hwnd), ERROR_INTERNAL_PROBLEM );
//			}
//			break;
//
//		case WM_KILLFOCUS:
//			if (!kbd->ResetEncodingTable( UseSecureTyping ))
//			{	// send NULL string to delete all tables, because problems occured 
//				kbd->FreeTables( UseSecureTyping );
//			}
//			break;
//		case WM_CHAR:
//			isLetter = TRUE;
//			letter = (char)wParam;
//			if ( kbd->TranslateChar( &letter, UseSecureTyping, (UINT)(lParam >> 16) ))
//			{	
//				if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//				{
//					wParam = (WPARAM)letter;
//				}
//				else if (UseSecureTyping)
//				{
//					charAdded = TRUE;
//				}
//			}
//			break;
//
//		case WM_KEYUP:
//			kbd->IncrementCharacterOrder( (int)wParam, UseSecureTyping );
//			if	(((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) == 0) &&
//				 ( UseSecureTyping && (wParam == 46) ) // DELETE key
//				)
//			{
//				letter = 46;
//				charAdded = TRUE;
//			}
//			break;
//		case WM_KEYDOWN:
//			kbd->IncrementCharacterOrderCNTRL( (int)wParam, UseSecureTyping );
//			break;
//	}
//
//	lpRes = CallWindowProc(wpEditOrigWndProc, hwnd, uMsg, wParam, lParam);
//
//	if (charAdded)
//	{
//		insertCharToPwdBuffer( hwnd, letter, Buffer, isLetter );
//	}
//
//	return lpRes;
//}

//LRESULT APIENTRY editSubclassProcA( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//	char letter;
//	LRESULT lpRes;
//	BOOL    isLetter;
//	UINT    virtualKey, scanCode;
//	DWORD   retCharsNum;
//	char    retChar1, retChar2;
//
//	isLetter = FALSE;
//	
//	kbdParams *kbd = kbdParams::GetParams( GetParent(hwnd) );
//	if ( kbd == NULL ) return 0;
//
//	switch (uMsg)
//	{
//		case WM_INPUTLANGCHANGE:
//		{
//			if (UseSecureTyping)
//			{
//				HWND hParent = GetParent( hwnd );
//
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//
//				kbd = kbdParams::Allocate();
//				if ( kbd != NULL )
//				{
//					SetWindowLong( hParent, DWL_USER, (LONG)kbd );
//					kbd->GenerateEncodingTable( UseSecureTyping );
//					kbd->SetEncodingTable( UseSecureTyping );
//				}
//				else
//				{
//					UseSecureTyping = false;
//				}
//			}
//
//			break;
//		}
//
//		case WM_SETFOCUS:
//			if (!kbd->SetEncodingTable( UseSecureTyping ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//				UseSecureTyping = false;
//				MessageBox( GetParent(hwnd), "Error in settiing encoding table", "KeyGen - editSubclassProcA", MB_ICONSTOP );
//				EndDialog( GetParent(hwnd), ERROR_INTERNAL_PROBLEM );
//			}
//			break;
//
//		case WM_KILLFOCUS:
//			if (!kbd->ResetEncodingTable( UseSecureTyping ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->FreeTables( UseSecureTyping );
//			}
//			break;
//
//		case WM_KEYDOWN:
//			
//			virtualKey = (UINT)wParam;
//			scanCode = (UINT)((lParam >> 16) & 0xFF);
//
//			kbd->Wm_KeyDown( virtualKey, UseSecureTyping, scanCode );
//			kbd->IncrementCharacterOrderCNTRL( (int)wParam, UseSecureTyping );
//			break;
//		
//		case WM_DEADCHAR:
//			kbd->Wm_DeadChar();
//			break;
//
//		case WM_CHAR:
//			{
//				letter = (char)wParam;
//				isLetter = TRUE;
//
//				if (kbd->Wm_Char( letter, UseSecureTyping, &retCharsNum, &retChar1, &retChar2 ))
//				{
//					if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//					{
//						if (retCharsNum == 2)
//						{
//							wParam = (WPARAM)retChar2;
//							CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, Buffer, BUFFER_SIZE, isLetter );
//							wParam = (WPARAM)retChar1;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar1, Buffer, BUFFER_SIZE, isLetter );
//						}
//						else
//						{
//							wParam = (WPARAM)retChar2;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, Buffer, BUFFER_SIZE, isLetter );
//						}
//					}
//					else if (UseSecureTyping)
//					{
//						if (retCharsNum == 2)
//						{
//							CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, Buffer, BUFFER_SIZE, isLetter );
//							letter = getRandomLetter();
//							wParam = (WPARAM)letter;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar1, Buffer, BUFFER_SIZE, isLetter );
//						}
//						else
//						{
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, Buffer, BUFFER_SIZE, isLetter );
//						}
//					}
//					else
//					{
//						lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//						insertCharToPwdBuffer( hwnd, retChar2, Buffer, BUFFER_SIZE, isLetter );
//					}
//				}
//				else
//				{
//					lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//					insertCharToPwdBuffer( hwnd, letter, Buffer, BUFFER_SIZE, isLetter );
//				}
//
//				return lpRes;
//			}
//
//		case WM_KEYUP:
//			{
//				kbd->IncrementCharacterOrder( (int)wParam, UseSecureTyping );
//				lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//
//				if	(((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) == 0) &&
//					 ( UseSecureTyping && (wParam == 46) ) // DELETE key
//					)
//				{
//					isLetter = FALSE;
//					letter = 46;
//					insertCharToPwdBuffer( hwnd, letter, Buffer, BUFFER_SIZE, isLetter );
//				}
//				
//				return lpRes;
//			}
//	}
//
//	lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//
//	return lpRes;
//}
//
//
//LRESULT APIENTRY editSubclassProcB( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//	char letter;
//	LRESULT lpRes;
//	BOOL    isLetter;
//	UINT    virtualKey, scanCode;
//	DWORD   retCharsNum;
//	char    retChar1, retChar2;
//
//	isLetter = FALSE;
//	
//	kbdParams *kbd = kbdParams::GetParams( GetParent(hwnd) );
//	if ( kbd == NULL ) return 0;
//
//	switch (uMsg)
//	{
//		case WM_INPUTLANGCHANGE:
//		{
//			if (UseSecureTyping)
//			{
//				HWND hParent = GetParent( hwnd );
//
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//
//				kbd = kbdParams::Allocate();
//				if ( kbd != NULL )
//				{
//					SetWindowLong( hParent, DWL_USER, (LONG)kbd );
//					kbd->GenerateEncodingTable( UseSecureTyping );
//					kbd->SetEncodingTable( UseSecureTyping );
//				}
//				else
//				{
//					UseSecureTyping = false;
//				}
//			}
//
//			break;
//		}
//
//		case WM_SETFOCUS:
//			if (!kbd->SetEncodingTable( UseSecureTyping ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//				UseSecureTyping = false;
//				MessageBox( GetParent(hwnd), "Error in settiing encoding table", "KeyGen - editSubclassProcB", MB_ICONSTOP );
//				EndDialog( GetParent(hwnd), ERROR_INTERNAL_PROBLEM );
//			}
//			break;
//
//		case WM_KILLFOCUS:
//			if (!kbd->ResetEncodingTable( UseSecureTyping ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->FreeTables( UseSecureTyping );
//			}
//			break;
//
//		case WM_KEYDOWN:
//			virtualKey = (UINT)wParam;
//			scanCode = (UINT)((lParam >> 16) & 0xFF);
//
//			kbd->Wm_KeyDown( virtualKey, UseSecureTyping, scanCode );
//			kbd->IncrementCharacterOrderCNTRL( (int)wParam, UseSecureTyping );
//			break;
//		
//		case WM_DEADCHAR:
//			kbd->Wm_DeadChar();
//			break;
//
//		case WM_CHAR:
//			{
//				letter = (char)wParam;
//				isLetter = TRUE;
//
//				if (kbd->Wm_Char( letter, UseSecureTyping, &retCharsNum, &retChar1, &retChar2 ))
//				{
//					if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//					{
//						if (retCharsNum == 2)
//						{
//							wParam = (WPARAM)retChar2;
//							CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, BufferB, BUFFER_SIZE, isLetter );
//							wParam = (WPARAM)retChar1;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar1, BufferB, BUFFER_SIZE, isLetter );
//						}
//						else
//						{
//							wParam = (WPARAM)retChar2;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, BufferB, BUFFER_SIZE, isLetter );
//						}
//					}
//					else if (UseSecureTyping)
//					{
//						if (retCharsNum == 2)
//						{
//							CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, BufferB, BUFFER_SIZE, isLetter );
//							letter = getRandomLetter();
//							wParam = (WPARAM)letter;
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar1, BufferB, BUFFER_SIZE, isLetter );
//						}
//						else
//						{
//							lpRes = CallWindowProc( (WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//							insertCharToPwdBuffer( hwnd, retChar2, BufferB, BUFFER_SIZE, isLetter );
//						}
//					}
//					else
//					{
//						lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//						insertCharToPwdBuffer( hwnd, retChar2, BufferB, BUFFER_SIZE, isLetter );
//					}
//				}
//				else
//				{
//					lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//					insertCharToPwdBuffer( hwnd, letter, BufferB, BUFFER_SIZE, isLetter );
//				}
//
//				return lpRes;
//			}
//
//		case WM_KEYUP:
//			{
//				kbd->IncrementCharacterOrder( (int)wParam, UseSecureTyping );
//				lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//
//				if	(((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) == 0) &&
//					 ( UseSecureTyping && (wParam == 46) ) // DELETE key
//					)
//				{
//					isLetter = FALSE;
//					letter = 46;
//					insertCharToPwdBuffer( hwnd, letter, BufferB, BUFFER_SIZE, isLetter );
//				}
//				
//				return lpRes;
//			}
//	}
//
//	lpRes = CallWindowProc((WNDPROC)wpEditOrigWndProcB, hwnd, uMsg, wParam, lParam);
//	return lpRes;
//}
//

//BOOL CALLBACK getPasswordDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//    WORD  pwdLength;
//	HWND  editHwnd, cmbHwnd = NULL;
//	int   i, selDrive = 0, curSel;
//	DWORD curLogicalDisks;
//	wchar_t  driveName[] = L"A:\\";
//
//	static HFONT hFont = NULL;
//
//	switch (uMsg) 
//	{ 
//		case WM_INITDIALOG:
//		{
//			if (Caption)  SetWindowTextT( hwnd, Caption );
//			if (FileName) SetWindowTextT( GetDlgItem(hwnd, IDC_TextName), FileName );
//			if (PathName) SetWindowTextT( GetDlgItem(hwnd, IDC_TextPath), PathName );
//
//			if (!UseSecureTyping) ShowWindow( GetDlgItem(hwnd, IDC_LINE), SW_HIDE );
//			
//			if ( headerIsEncrypted )
//			{
//				HWND hChk = GetDlgItem(hwnd, IDC_AUTOMOUNT);
//				SetWindowText( hChk, "Decrypt header" );
//				Button_SetCheck( hChk, false );
//			}
//			else
//				Button_SetCheck( GetDlgItem(hwnd, IDC_AUTOMOUNT), (KeyGenFlags & FLAG_CONTAINER_AUTO_MOUNT) > 0);
//
//			Button_SetCheck( GetDlgItem(hwnd, IDC_READONLY),  (KeyGenFlags & FLAG_CONTAINER_READ_ONLY) > 0);
//
//			if ( KeyGenFlags & FLAG_FORCE_READ_ONLY )
//			{
//				Button_SetCheck( GetDlgItem(hwnd, IDC_READONLY),  TRUE  );
//				Button_Enable  ( GetDlgItem(hwnd, IDC_READONLY),  FALSE );
//			}
//
//			if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//			{
//				Edit_SetPasswordChar(GetDlgItem(hwnd, IDC_PASS), 0);
//			}
//			else
//			{
//				if ( changeFont )
//					hFont = CreateFont(0,0,0,0, FW_NORMAL, FALSE, FALSE, FALSE, 
//							DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
//							DEFAULT_PITCH, szPwdFontName );
//
//				if ( hFont != NULL )
//				{
//					SendMessage( GetDlgItem( hwnd, IDC_PASS ), WM_SETFONT, (WPARAM)hFont, false );
//				}
//			}
//
//			cmbHwnd = GetDlgItem(hwnd, IDC_DRIVES);
//
//			if ((KeyGenFlags & FLAG_MOUNT_ON_SINGLE_LETTER) != 0)
//			{
//				driveName[0] = L'A' + (int)KeyGenFavoriteDrive;
//				ComboBoxEx_InsertString( cmbHwnd, 0, driveName);
//				selDrive = 0;
//			}
//			else
//			{
//				curLogicalDisks = _GetLogicalDrives();
//
//				for (i=2, curSel=0; i<26; i++ )
//				{
//					if ((curLogicalDisks & (1 << i)) == 0)
//					{
//						driveName[0] = L'A' + i;
//						int num = ComboBox_InsertString( cmbHwnd, curSel, driveName );
//						ComboBoxEx_InsertString( cmbHwnd, curSel, driveName );
//
//						if (i == (int)KeyGenFavoriteDrive)
//						{ selDrive = curSel; }
//
//						curSel++;
//					}
//				}
//
//				ComboBox_SetCurSel( cmbHwnd, selDrive);
//
//				if ( wcMountPoint != NULL )
//				{
//					ComboBoxEx_InsertString( cmbHwnd, curSel, L"<Browse for Mount Point ... >"  );
//					posBrowseForMountPoint = curSel;
//
//					curSel++;
//
//					int len = wcslen( wcMountPoint );
//					if ( len != 0 )
//					{
//						SelectString( cmbHwnd, wcMountPoint );
////						ComboBoxEx_InsertString( cmbHwnd, curSel, wcMountPoint );
////						selDrive = curSel;
//					}
//				}
//			}
//
//
//			// Set the default push button to "Cancel"
//			SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDCANCEL, (LPARAM) 0); 
//
//			editHwnd = GetDlgItem(hwnd, IDC_PASS); 
//
////			wpEditOrigWndProcA = SetWindowLong(editHwnd,GWL_WNDPROC, (LONG) editSubclassProcA);
//
//
//			kbdParams *kbd = kbdParams::Allocate();
//			if ( kbd == NULL )	{ assert( false ); return false; }
//			SetWindowLong( hwnd, DWL_USER, (LONG)kbd );
//			
//			return (kbd->GenerateEncodingTable( UseSecureTyping ));
//		}
//		case WM_DESTROY:
//		{
//			if ( hFont != NULL )
//			{
//				DeleteObject( hFont );
//				hFont = NULL;
//			}
//
//			// Retrieve the handle of the edit control
//			editHwnd = GetDlgItem(hwnd, IDC_PASS);
//
//			// Remove the subclass from the edit control.
//			SetWindowLong(editHwnd, GWL_WNDPROC, (LONG) wpEditOrigWndProcA); 
//
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd != NULL ) return 0;
//			kbdParams::Free( kbd );
//
//			break;
//		}
//		case WM_COMMAND: 
//		{
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//
//			/* Set the default push button to "OK" when the user enters text */
//			if((HIWORD (wParam) == EN_CHANGE) && (LOWORD(wParam) == IDC_PASS)) 
//				SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDOK, (LPARAM) 0); 
//	
//			if ( HIWORD(wParam) == CBN_SELCHANGE )
//			{
//				cmbHwnd = GetDlgItem( hwnd, IDC_DRIVES );
//
//				if ((HWND)lParam == cmbHwnd )
//				{
//					curSel = ComboBox_GetCurSel( cmbHwnd );
//
//					if ( curSel == posBrowseForMountPoint )
//					{
//						while( true ) 
//						{
//							if ( !BrowseForFolderT( hMainInst, IDS_ChooseFolderForMounting, hwnd, wcMountPoint ) )
//							{
//								ComboBox_SetCurSel( cmbHwnd, 0 );
//								return false;
//							}
//							
//							int len = wcslen( wcMountPoint );
//							if ( len == 0 )
//								return false;
//
//							if ( wcMountPoint[ len - 1 ] != L'\\' )
//								wcscpy( wcMountPoint + len, L"\\" );
//
//							if ( isEmptyFolder( wcMountPoint ) )
//								break;
//
//							wchar_t text[ 1024 ];
//
//							cDlgFuncsHolder::FormatT_S(
//									text, maxLen,  
//									L"Folder %s\n"
//									L"is not empty\n"
//									L"So it cannot be used as mount point.",
//									wcMountPoint );
//
//							MessageBoxT( hwnd, text, L"Warning!", MB_ICONEXCLAMATION );
//						} 
//
//						SelectString( cmbHwnd, wcMountPoint );
//					}
//				}
//
//				break;
//			}
//			
//
//			switch( LOWORD( wParam ) ) 
//			{ 
//				case IDOK:
//				{
//					if ( headerIsEncrypted )
//					{
//						HWND hChk = GetDlgItem(hwnd, IDC_AUTOMOUNT);
//						if ( Button_GetCheck( hChk ) )
//							headerIsEncrypted = false;
//					}
//
//					// Gets number of characters. 
//					pwdLength = (WORD) SendDlgItemMessage( hwnd, IDC_PASS,
//									EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0); 
//
//					if (pwdLength == 0) 
//					{
//						MessageBoxT( hwnd,
//							LoadStringOnceT( hMainInst, IDS_PASSWORD_EMPTY ),
//							LoadStringTwiceT( hMainInst, IDS_INVALID_PWD ),
//							MB_OK | MB_ICONWARNING );
//
//						return 0; /* Let user to continue to edit password */ 
//					} 
//		            
//					pwdLength = pwdLength < PASSWORD_MAXIMUM_LENGTH ? pwdLength : PASSWORD_MAXIMUM_LENGTH;
//					Buffer[pwdLength] = Password[pwdLength] = 0;
//					wcsncpy(Password, Buffer, pwdLength);
//
//					kbd->FreeTables( UseSecureTyping );
//	
//					if ( Button_GetCheck( GetDlgItem(hwnd, IDC_AUTOMOUNT)))
//							{ KeyGenFlags |= FLAG_CONTAINER_AUTO_MOUNT; }
//					else	{ KeyGenFlags &= ~FLAG_CONTAINER_AUTO_MOUNT; }
//
//					if ( Button_GetCheck( GetDlgItem(hwnd, IDC_READONLY)))
//						KeyGenFlags |= FLAG_CONTAINER_READ_ONLY;
//					else KeyGenFlags &= ~FLAG_CONTAINER_READ_ONLY;
//
//					curSel = ComboBox_GetCurSel( GetDlgItem(hwnd, IDC_DRIVES) );
//					if ( ( curSel == posBrowseForMountPoint + 1 ) && ( wcMountPoint != NULL ) )
//					{
//						ComboBoxEx_GetText( GetDlgItem(hwnd, IDC_DRIVES), wcMountPoint, MAX_PATH );
//						KeyGenFavoriteDrive = (DWORD)-1;
//					}
//					else
//					{
//						if ( ComboBoxEx_GetText( GetDlgItem(hwnd, IDC_DRIVES), driveName, maxLen(driveName)) != 0 )
//							KeyGenFavoriteDrive = (DWORD)(driveName[0] - L'A');
//					}
//
//					EndDialog(hwnd, ERROR_NO);
//					return TRUE; 
//				}
//				case IDCANCEL: 
//				{
//					if ( Button_GetCheck( GetDlgItem(hwnd, IDC_AUTOMOUNT)))
//							{ KeyGenFlags |= FLAG_CONTAINER_AUTO_MOUNT; }
//					else	{ KeyGenFlags &= ~FLAG_CONTAINER_AUTO_MOUNT; }
//
//					if ( Button_GetCheck( GetDlgItem(hwnd, IDC_READONLY)))
//						KeyGenFlags |= FLAG_CONTAINER_READ_ONLY;
//					else KeyGenFlags &= ~FLAG_CONTAINER_READ_ONLY;
//
//					kbd->FreeTables( UseSecureTyping );
//	
//					Static_SetText(GetDlgItem(hwnd, IDC_PASS), "qwerty");
//					EndDialog(hwnd, (int)ERROR_CANCELLED_BY_USER); 
//					return TRUE; 
//				}
//			} 
//			return 0; 
//		}
//	} 
//
//    return FALSE; 
//
//	UNREFERENCED_PARAMETER(lParam);
//}
//
//
//BOOL CALLBACK getPasswordDlgProcSimple( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//    WORD  pwdLength;
//	HWND  editHwnd;
// 
//	static HFONT hFont = NULL;
//
//	switch (uMsg) 
//	{ 
//        case WM_INITDIALOG:
//		{
//			if ( wcslen(Caption))  SetWindowTextT( hwnd, Caption );
//			if ( wcslen(FileName)) SetWindowTextT( GetDlgItem(hwnd, IDC_TextName), FileName );
//			if ( wcslen(PathName)) SetWindowTextT( GetDlgItem(hwnd, IDC_TextPath), PathName );
//			if ( wcslen(NotFileName)) SetWindowTextT( GetDlgItem(hwnd, IDC_NotFileName), NotFileName );
//
//			if ( wcslen(PathName) == 0 )
//			{
//				ShowWindow( GetDlgItem(hwnd, IDC_Text), SW_HIDE );
//				ShowWindow( GetDlgItem(hwnd, IDC_TextName), SW_HIDE );
//				ShowWindow( GetDlgItem(hwnd, IDC_TextPath), SW_HIDE );
//				ShowWindow( GetDlgItem(hwnd, IDC_Location), SW_HIDE );
//			}
//			else
//			{
//				ShowWindow( GetDlgItem(hwnd, IDC_NotFileName), SW_HIDE );
//			}
//
//			if (!UseSecureTyping) ShowWindow( GetDlgItem(hwnd, IDC_LINE), SW_HIDE );
//
//			if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//			{
//				Edit_SetPasswordChar(GetDlgItem(hwnd, IDC_PASS), 0);
//			}
//			else
//			{
//				if ( changeFont )
//					hFont = CreateFont(0,0,0,0, FW_NORMAL, FALSE, FALSE, FALSE, 
//						DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
//						DEFAULT_PITCH, szPwdFontName);
//
//				if ( hFont != NULL )
//				{
//					SendMessage( GetDlgItem( hwnd, IDC_PASS ), WM_SETFONT, (WPARAM)hFont, false );
//				}
//			}
//
//			/* Set the default push button to "Cancel" */ 
//			SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDCANCEL, (LPARAM) 0); 
//
//			editHwnd = GetDlgItem(hwnd, IDC_PASS); 
//
//			wpEditOrigWndProcA = SetWindowLong(editHwnd,GWL_WNDPROC, (LONG) editSubclassProcA);
//			
//			kbdParams *kbd = kbdParams::Allocate();
//			if ( kbd == NULL )	{ assert( false ); return false; }
//			SetWindowLong( hwnd, DWL_USER, (LONG)kbd );
//
//			return kbd->GenerateEncodingTable( UseSecureTyping );
//
//			//return TRUE;
//		}
//		case WM_DESTROY:
//		{
//			if ( hFont != NULL )
//			{
//				DeleteObject( hFont );
//				hFont = NULL;
//			}
//
//			// Retrieve the handle of the edit control
//			editHwnd = GetDlgItem(hwnd, IDC_PASS);
//
//			// Remove the subclass from the edit control.
//			SetWindowLong(editHwnd, GWL_WNDPROC, (LONG) wpEditOrigWndProcA); 
//
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//			kbdParams::Free( kbd );
//
//			break;
//		}
//        case WM_COMMAND: 
//		{
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//
//			/* Set the default push button to "OK" when the user enters text */
//			if((HIWORD (wParam) == EN_CHANGE) && (LOWORD(wParam) == IDC_PASS)) 
//				SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDOK, (LPARAM) 0); 
// 
//			switch(wParam) 
//			{ 
//				case IDOK: 
//					// Gets number of characters.
//					pwdLength = (WORD) SendDlgItemMessage( hwnd, IDC_PASS,
//									EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0); 
//
//                    if (pwdLength == 0) 
//					{
//						MessageBoxT( hwnd,
//							LoadStringOnceT( hMainInst, IDS_PASSWORD_EMPTY ),
//							LoadStringTwiceT( hMainInst, IDS_INVALID_PWD ),
//							MB_OK | MB_ICONWARNING );
//
//						return 0; /* Let user to continue to edit password */ 
//                    } 
//                    
//					pwdLength = pwdLength < PASSWORD_MAXIMUM_LENGTH ? pwdLength : PASSWORD_MAXIMUM_LENGTH;
//					Buffer[pwdLength] = Password[pwdLength] = 0;
//					wcsncpy( Password, Buffer, pwdLength );
//					
//					kbd->FreeTables( UseSecureTyping );
//
//					Static_SetText(GetDlgItem(hwnd, IDC_PASS), "qwerty");
//					EndDialog(hwnd, ERROR_NO);
//					return TRUE; 
// 
//				case IDCANCEL: 
//					kbd->FreeTables( UseSecureTyping );
//	
//					Static_SetText(GetDlgItem(hwnd, IDC_PASS), "qwerty");
//					EndDialog(hwnd, (int)ERROR_CANCELLED_BY_USER); 
//					return TRUE; 
//            } 
//            return 0; 
//		}
//    } 
//    return FALSE; 
//
//	UNREFERENCED_PARAMETER(lParam);
//}

//BOOL CALLBACK getPasswordVerifyDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//    WORD pwdLength;
//	char tmpStr[ PASSWORD_MAXIMUM_LENGTH + 4 ];
//	WORD tmpStrLength;
//	HWND editHwndA, editHwndB;
//
//	static HFONT hFont = NULL;
// 
//	switch (uMsg) 
//	{ 
//        case WM_INITDIALOG: 
//		{	
//			if (Caption)  SetWindowTextT( hwnd, Caption );
//			if (FileName) SetWindowTextT( GetDlgItem(hwnd, IDC_TextName), FileName );
//			if (PathName) SetWindowTextT( GetDlgItem(hwnd, IDC_TextPath), PathName );
//
//			if (!UseSecureTyping) 
//			{	ShowWindow( GetDlgItem(hwnd, IDC_LINEC), SW_HIDE );
//				ShowWindow( GetDlgItem(hwnd, IDC_LINEB), SW_HIDE );
//			}
//
//			if ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0)
//			{
//				Edit_SetPasswordChar(GetDlgItem(hwnd, IDC_PASSA), 0);
//				Edit_SetPasswordChar(GetDlgItem(hwnd, IDC_PASSB), 0);
//			}
//
//			/* Set the default push button to "Cancel" */ 
//			SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDCANCEL, (LPARAM) 0); 
//
//			editHwndA = GetDlgItem(hwnd, IDC_PASSA); 
//			editHwndB = GetDlgItem(hwnd, IDC_PASSB); 
//
//			wpEditOrigWndProcA = SetWindowLong(editHwndA, GWL_WNDPROC, (LONG) editSubclassProcA);
//			wpEditOrigWndProcB = SetWindowLong(editHwndB, GWL_WNDPROC, (LONG) editSubclassProcB);
//
//			kbdParams *kbd = kbdParams::Allocate();
//			if ( kbd == NULL )	{ assert( false ); return false; }
//			SetWindowLong( hwnd, DWL_USER, (LONG)kbd );
//
//			return kbd->GenerateEncodingTable( UseSecureTyping );
//		}
//		case WM_DESTROY:
//		{
//			if ( hFont != NULL )
//			{
//				DeleteObject( hFont );
//				hFont = NULL;
//			}
//
//			// Retrieve the handle of the edit control
//			editHwndA = GetDlgItem(hwnd, IDC_PASSA);
//			editHwndB = GetDlgItem(hwnd, IDC_PASSB);
//
//			// Remove the subclass from the edit control.
//			SetWindowLong(editHwndA, GWL_WNDPROC, (LONG) wpEditOrigWndProcA); 
//			SetWindowLong(editHwndB, GWL_WNDPROC, (LONG) wpEditOrigWndProcB);
//
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//			kbdParams::Free( kbd );
//
//			break;
//		}
//        case WM_COMMAND: 
//		{
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//
//			/* Set the default push button to "OK" when the user enters text */
//			if((HIWORD (wParam) == EN_CHANGE) && (LOWORD(wParam) == IDC_PASSA)) 
//				SendMessage(hwnd, DM_SETDEFID, (WPARAM) IDOK, (LPARAM) 0); 
// 
//			switch(wParam) 
//			{ 
//				case IDC_btnAdvanced:
//					kbd->FreeTables( UseSecureTyping );
// 
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSA), "qwerty");
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSB), "qwerty");
//					EndDialog(hwnd, ERROR_AdvancedDlgRequired); 
//					return TRUE; 
//				case IDOK: 
//					/* Get number of characters. */ 
//					pwdLength = (WORD) SendDlgItemMessage( hwnd, IDC_PASSA,
//									EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0); 
//					
//                    if (pwdLength < PASSWORD_MINIMUM_LENGTH) 
//					{	char msgText[128];
//						char captionText[32];
//						LoadString( hMainInst, IDS_PWD_TOO_SHORT, msgText, sizeof(msgText) );
//						LoadString( hMainInst, IDS_INVALID_PWD, captionText, sizeof(captionText) );
//						MessageBox( hwnd, msgText, captionText, MB_OK | MB_ICONWARNING );
//						SetFocus( GetDlgItem( hwnd, IDC_PASSA ));
//						return 0; /* Let user to continue to edit password */ 
//                    } 
//                    
//					pwdLength = pwdLength < PASSWORD_MAXIMUM_LENGTH ? pwdLength : PASSWORD_MAXIMUM_LENGTH;
//					/*
//					if ( ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0) || (!UseSecureTyping) )
//					{
//						// Put the number of characters into first word of buffer
//						*((LPWORD)Password) = pwdLength; 
// 
//						// Get the characters.
//						SendDlgItemMessage(hwnd, IDC_PASSA, EM_GETLINE, (WPARAM) 0, (LPARAM)Password); 
// 
//						Password[pwdLength] = 0; // Null-terminate the string.
// 
//						//Get the password verification string
//						tmpStrLength = (WORD) SendDlgItemMessage( hwnd, IDC_PASSB, 
//										EM_LINELENGTH, (WPARAM) 0, (LPARAM) 0);
//					}
//					else
//					*/
//					{
//						Buffer[pwdLength] = Password[pwdLength] = 0;
//						memcpy(Password, Buffer, pwdLength);
//						tmpStrLength = strlen( BufferB );
//					}
//
//					if (tmpStrLength == 0)
//					{	SetFocus( GetDlgItem( hwnd, IDC_PASSB ));
//						return 0; /* let user to type the second copy of password */
//					}
//					else if (tmpStrLength != pwdLength)
//					{
//						ShowErrorMismatch( hwnd );
//						SetFocus( GetDlgItem( hwnd, IDC_PASSB ));
//						return 0;
//					}
//					/*
//					if ( ((KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0) || (!UseSecureTyping) )
//					{
//						*((LPWORD)tmpStr) = pwdLength; 
//						SendDlgItemMessage(hwnd, IDC_PASSB, EM_GETLINE, (WPARAM) 0, (LPARAM)tmpStr); 
//						tmpStr[pwdLength] = 0; // Null-terminate the string.
//					}
//					else
//					*/
//					{
//						BufferB[pwdLength] = tmpStr[pwdLength] = 0;
//						memcpy(tmpStr, BufferB, pwdLength);
//					}
//
//					if (strcmp( tmpStr, Password ) != 0)
//					{
//						ShowErrorMismatch( hwnd );
//						SetFocus( GetDlgItem( hwnd, IDC_PASSB ));
//						return 0;
//					}
//
//					kbd->FreeTables( UseSecureTyping );
// 
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSA), "qwerty");
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSB), "qwerty");
//					EndDialog(hwnd, ERROR_NO); 
//					return TRUE; 
// 
//				case IDCANCEL: 
//					
//					kbd->FreeTables( UseSecureTyping );
//
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSA), "qwerty");
//					Static_SetText(GetDlgItem(hwnd, IDC_PASSB), "qwerty");
//					EndDialog(hwnd, (int)ERROR_CANCELLED_BY_USER); 
//					return TRUE; 
//            } 
//
//            return 0; 
//		}
//    } 
//    return FALSE;
//
//	UNREFERENCED_PARAMETER(lParam); 
//}

// Local: Get Advanced settings procedure

//LRESULT APIENTRY editSubclassProcAdvanced( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//	UINT virtualKey, scanCode;
//	char letter;
//
//	kbdParams *kbd = kbdParams::GetParams( GetParent( hwnd ) );
//	if ( kbd == NULL ) return 0;
//
//	switch (uMsg)
//	{
//		case WM_INPUTLANGCHANGE:
//		{
//			if (UseSecureTyping)
//			{
//				HWND hParent = GetParent( hwnd );
//
//				kbd->ResetEncodingTable( UseSecureTyping );
//				kbd->FreeTables( UseSecureTyping );
//
//				kbd = kbdParams::Allocate();
//				if ( kbd != NULL )
//				{
//					SetWindowLong( hParent, DWL_USER, (LONG)kbd );
//					kbd->GenerateEncodingTable( UseSecureTyping );
//					kbd->SetEncodingTable( UseSecureTyping );
//				}
//				else
//				{
//					UseSecureTyping = false;
//				}
//			}
//
//			break;
//		}
//
//		case WM_SETFOCUS:
//			if (!kbd->SetEncodingTable( TRUE ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->ResetEncodingTable( TRUE );
//				kbd->FreeTables( TRUE );
//				MessageBox( GetParent(hwnd), "Error in settiing encoding table", "KeyGen - editSubclassProcAdvanced", MB_ICONSTOP );
//				EndDialog( GetParent(hwnd), ERROR_INTERNAL_PROBLEM );
//			}
//			break;
//
//		case WM_KILLFOCUS:
//			if (!kbd->ResetEncodingTable( TRUE ))
//			{	/* send NULL string to delete all tables, because problems occured */
//				kbd->FreeTables( TRUE );
//			}
//			break;
//
//		case WM_KEYDOWN:
//			virtualKey = (UINT)wParam;
//			scanCode = (UINT)((lParam >> 16) & 0xFF);
//
//			kbd->Wm_KeyDown( virtualKey, UseSecureTyping, scanCode );
//			kbd->IncrementCharacterOrderCNTRL( (int)wParam, UseSecureTyping );
//			break;
//		
//		case WM_DEADCHAR:
//			kbd->Wm_DeadChar();
//			break;
//
//		case WM_CHAR:
//			{
//				DWORD retCharsNum;
//				char  retChar1, retChar2;
//
//				letter = (char)wParam;
//
//				if (kbd->Wm_Char( letter, UseSecureTyping, &retCharsNum, &retChar1, &retChar2 ))
//				{
//					if (retCharsNum == 2)
//					{
//						wParam = (WPARAM)retChar2;
//						CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//						wParam = (WPARAM)retChar1;
//					}
//					else
//					{
//						wParam = (WPARAM)retChar2;
//					}
//				}
//
//				break;
//			}
//
//		case WM_KEYUP:
//			kbd->IncrementCharacterOrder( (int)wParam, UseSecureTyping );
//			break;
//	}
//
//	return CallWindowProc((WNDPROC)wpEditOrigWndProcA, hwnd, uMsg, wParam, lParam);
//}

//BOOL CALLBACK getAdvancedFlagsDlgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
//{
//	HWND  editHwnd;
// 
//	switch (uMsg) 
//	{ 
//        case WM_INITDIALOG:
//		{
//			Button_SetCheck( GetDlgItem(hwnd, IDC_STYPING),  (KeyGenFlags & FLAG_ADVANCED_SECURE_TYPING) > 0);
//			Button_SetCheck( GetDlgItem(hwnd, IDC_SHOWCHARS),(KeyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) > 0);
//
//			editHwnd = GetDlgItem(hwnd, IDC_EDITSTRING); 
//
//			wpEditOrigWndProcA = SetWindowLong(editHwnd,GWL_WNDPROC, (LONG) editSubclassProcAdvanced);
//
//			kbdParams *kbd = kbdParams::Allocate();
//			if ( kbd == NULL )	{ assert( false ); return false; }
//			SetWindowLong( hwnd, DWL_USER, (LONG)kbd );
//
//			return (kbd->GenerateEncodingTable( TRUE ));
//		}
//		case WM_DESTROY:
//		{
//			// Retrieve the handle of the edit control
//			editHwnd = GetDlgItem(hwnd, IDC_EDITSTRING);
//
//			// Remove the subclass from the edit control.
//			SetWindowLong(editHwnd, GWL_WNDPROC, (LONG) wpEditOrigWndProcA); 
//
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//			kbdParams::Free( kbd );
//
//			break;
//		}
//		case WM_COMMAND: 
//		{
//			kbdParams *kbd = kbdParams::GetParams( hwnd );
//			if ( kbd == NULL ) return 0;
//
//			switch(wParam) 
//			{ 
//				case IDOK: 
//					kbd->FreeTables( UseSecureTyping );
// 
//			        if ( Button_GetCheck( GetDlgItem(hwnd, IDC_STYPING)))
//						 KeyGenFlags |= FLAG_ADVANCED_SECURE_TYPING;
//					else KeyGenFlags &= ~FLAG_ADVANCED_SECURE_TYPING;
//
//			        if ( Button_GetCheck( GetDlgItem(hwnd, IDC_SHOWCHARS)))
//						 KeyGenFlags |= FLAG_ADVANCED_SHOW_PWD_CHARS;
//					else KeyGenFlags &= ~FLAG_ADVANCED_SHOW_PWD_CHARS;
//
//					Static_SetText(GetDlgItem(hwnd, IDC_EDITSTRING), "qwerty");
//					EndDialog(hwnd, ERROR_NO);
//					return TRUE; 
// 
//				case IDCANCEL: 
//					kbd->FreeTables( UseSecureTyping );
//	
//					Static_SetText(GetDlgItem(hwnd, IDC_EDITSTRING), "qwerty");
//					EndDialog(hwnd, (int)ERROR_CANCELLED_BY_USER); 
//					return TRUE; 
//			} 
//            return 0; 
//		}
//    } 
//    return FALSE; 
//
//	UNREFERENCED_PARAMETER(lParam);
//}
//

//BOOL convertTextToFilenamePath( LPCSTR Text )
//{
//	// input Text has a form: "Container:  D:\path\container_name.jbc"
//	// we return: ContainerName = "container_name.jbc", 
//	//            ContainerPath = "D:\path\"
//
//	int  i,j, pathLen, nameLen;
//	const char *pathPtr = NULL, *namePtr = NULL;
//
//	if (!Text) return FALSE;
//
//	for( i=strlen(Text); i>0; i--)
//	{
//		if ((Text[i] == ' ') && (Text[i-1] == ':'))
//		{
//			pathPtr = &(Text[i]);
//			j = i;
//			while (Text[j++] == ' ') pathPtr = &(Text[j]);
//			break;
//		}
//	}
//
//	if (!pathPtr) pathPtr = Text;
//
//	for( i=strlen(Text); i>0; i--)
//	{
//		if (Text[i] == '\\')
//		{
//			namePtr = &(Text[i+1]);
//			break;
//		}
//	}
//
//	if (!namePtr) namePtr = Text;
//
//	pathLen = strlen(pathPtr);
//	nameLen = strlen(namePtr);
//
//	if (pathLen > 128) pathLen = 128;
//	if (nameLen > 128) nameLen = 128;
//
//	memcpy( FileName, namePtr, nameLen );
//	FileName[127] = '\0';
//
//	memcpy( PathName, pathPtr, pathLen );
//	PathName[127] = '\0';
//
//	for( i=strlen(PathName); i>0; i--)
//	{
//		if (PathName[i] == '\\')
//		{
//			PathName[i+1] = '\0';
//			break;
//		}
//	}
//
//	return TRUE;
//}
