/*******************************************************************
 *
 *	Copyright (c) 1994-2008 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	File: pwdlg.h
 *	Revision: 
 *	Created:
 *	Description: declaration of procedures that support 
 *		dialog boxes for accepting user's password and 
 *		dialog that supports generation of seed value for 
 *		random key generation
 *
 *******************************************************************/

#pragma once

#include <windows.h>

class cPassword;

extern DWORD GetPassword( 
		HWND   hWnd,
		const wchar_t *text,
		const wchar_t *caption,
		cPassword *pwd,
		DWORD  *pFlags = NULL,
//		bool *pIsEncrypted = NULL,
		wchar_t *mountPoint = NULL
	);

class cKeyBlockParams;

extern DWORD GetKeyBlockParamsWithVerification_Advanced(
		HWND   hWndParent,
		const wchar_t *text,
		const wchar_t *caption,
		cKeyBlockParams *kbParams,
		DWORD  *pFlags,
		DWORD maxFreeSize,
		bool simple = false // Use dialog with two edits and advanced button only
	);

extern DWORD GetKeyBlockParamsWithVerification(
		HWND hWnd,
		const wchar_t	*text,
		const wchar_t	*caption,
		cKeyBlockParams *kbParams,
		DWORD *pFlags,
		DWORD maxFreeSize = -1 //  -1 means max available
	);

//
//	GetKeyBlockParams
//		Uses GetPassword to fills kbPBE.m_pwd buffers only.
//
extern DWORD GetKeyBlockParams(
		HWND hWnd,
		const wchar_t	*text,
		const wchar_t	*caption,
		cKeyBlockParams *kbParams,
		DWORD *pFlags,
//		bool *pIsEncrypted = NULL,
		wchar_t *mountPoint = NULL
	);

extern DWORD GetAdvancedFlags( 
			DWORD *Flags,
			HWND  hWndParent
			);

//
//	GetPasswordFromCommandLine
//		Reads password from command line, see GetKeyBlockParamsWithVerification and GetPassword functions.
//		The seed generation function uses the password for seed buffer generation, see GetSeedValue.
//		Note! It is not secure to pass password as command line.
//
extern BOOL	GetPasswordFromCommandLine(
		wchar_t *Password,	// buffer size is 256 symbols
		DWORD   *pFlags = NULL,
		wchar_t *mountPoint = NULL
	);
