#pragma once

#include "KBlock.h"
#include "cDlg.h"
#include "cKeyBlockParams.h"

class cProgressDlg_EncHeaderParse : public cDlg
{
	DATA_BLOCK	*m_dataBlock;
	DWORD		m_dbSize;
	cKeyBlockParams *m_pKBParams;
	KEY_HANDLE	*m_pKeyHandle;
	sKeyInfo	*m_pKeyInfoCopy;
	dbHeader	*m_pDecryptedHeader;
	DWORD		*m_pErrCode;

	sKeyMapInfo	*m_pKeyMapInfo;

	bool m_cancelled;
	HWND m_hProgress;

public:
	int m_res;

	cProgressDlg_EncHeaderParse(
			DWORD			*pErrCode,
			DATA_BLOCK		*dataBlock,
			DWORD			dbSize,
			cKeyBlockParams *pKBParams,
			KEY_HANDLE		*pKeyHandle,
			sKeyInfo		*pKeyInfoCopy,
			dbHeader		*pDecryptedHeader,
			sKeyMapInfo		*pKeyMapInfo
		)
	{
		m_res = -1;
		m_cancelled = false;

		m_pErrCode			= pErrCode;
		m_dataBlock			= dataBlock;
		m_dbSize			= dbSize;
		m_pKBParams			= pKBParams;
		m_pKeyHandle		= pKeyHandle;
		m_pKeyInfoCopy		= pKeyInfoCopy;
		m_pDecryptedHeader	= pDecryptedHeader;
		m_pKeyMapInfo		= pKeyMapInfo;
		m_hProgress			= 0;
	}

	BOOL InitDialog();
	void SetAlgTxt( int idc, const char *algName, int num, int Q );
	void SetAlgTxt( int idc, const wchar_t *algName, int num, int Q );
	LRESULT RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	static DWORD WINAPI threadFunc( void *ptr );

	int Run();
};
