#include "cDlgKBParams.h"
#include "resource.h" 
#include <windowsx.h>
#include "..\..\..\CertificateLib\hashAlgs\hashAlgs.h"
//#include "HELP\HelpIds.h"
#include "alg.h"

////////////////////////////
//
//	PBE Functions 
//

static int PBE_ItemTab[] = {
	IDC_stPBE1,
	IDC_stPBE2,
	IDC_stPBE3,
	IDC_stPBE4,
	IDC_stPBE5,
	IDC_cmbPBE_EncAlg,
	IDC_cmbPBE_HashAlg,
	IDC_cmbPBE_EncMode,
	IDC_pwdPBEA,
	IDC_linePBEA,
	IDC_pwdPBEB,
	IDC_linePBEB
};

//#define IDH_cmbPBE_EncAlg	118
//#define IDH_cmbPBE_HashAlg	119

//static int MenuHelpIDsT[] = {
//	IDC_cmbType,		IDH_KeyBlockTypesPBE,
//	IDC_grpType,		IDH_KeyBlockTypesPBE,
//	IDC_cmbPBE_EncAlg,	IDH_cmbPBE_EncAlg,
//	IDC_stPBE3,			IDH_cmbPBE_EncAlg,
//	IDC_cmbPBE_HashAlg,	IDH_cmbPBE_HashAlg,
//	IDC_stPBE4,			IDH_cmbPBE_HashAlg,
//	IDC_pwdPBEA,		IDH_Password,
//	IDC_stPBE1,			IDH_Password,
//	IDC_linePBEA,		IDH_KBD_Line,
//	IDC_pwdPBEB,		IDH_PasswordConfirm,
//	IDC_stPBE2,			IDH_PasswordConfirm,
//	IDC_linePBEB,		IDH_KBD_Line,
//	0,0
//};

static int MenuHelpIDsT[] = {
	IDC_cmbType,		IDH_KeyBlockTypesPBE,
	IDC_grpType,		IDH_KeyBlockTypesPBE,
	IDC_cmbPBE_EncAlg,	IDH_cmbPBE_EncAlg,
	IDC_stPBE3,			IDH_cmbPBE_EncAlg,
	IDC_cmbPBE_HashAlg,	IDH_cmbPBE_HashAlg,
	IDC_stPBE4,			IDH_cmbPBE_HashAlg,
	IDC_pwdPBEA,		IDH_Password,
	IDC_stPBE1,			IDH_Password,
	IDC_linePBEA,		IDH_KBD_Line,
	IDC_pwdPBEB,		IDH_PasswordConfirm,
	IDC_stPBE2,			IDH_PasswordConfirm,
	IDC_linePBEB,		IDH_KBD_Line,
	IDC_cmbPBE_EncMode,	IDH_cmbPBE_EncMode,
	0,0
};


void cPagePBE::ShowItems( bool show )
{
	for ( int i = 0; i < sizeof( PBE_ItemTab )/sizeof( int ); i++ )
	{
		ShowWindow( GetDlgItem( m_hDlg, PBE_ItemTab[i] ), show ? SW_SHOW : SW_HIDE );
	}

	if ( !m_useSecureTyping )
	{
		ShowWindow( GetDlgItem( m_hDlg, IDC_linePBEA ), SW_HIDE );
		ShowWindow( GetDlgItem( m_hDlg, IDC_linePBEB ), SW_HIDE );
	}

	if ( show )
	{
		SetFocus( m_edtA.m_hEdit );
		bool enable = cKbdEdit::CheckAndGetPassword( &(m_dlg->m_kbParams->kbPBE.m_pwd ), &m_edtA, &m_edtB, true );
		EnableWindow( GetDlgItem( m_hDlg, IDOK ), enable );
	}
}

static cEnumEncModes modes;

static void updateModesCmb( HWND hCmb, DWORD algId, cDlgKBParams *dlg )
{
	ComboBox_ResetContent( hCmb );

	int def = 0;

	for ( int i = 0 ; i < modes.Q; i++ )
	{
		cSymAlgorithm cAlg;

		if ( !cAlg.Init( algId, modes.T[i].id ) )
			continue;

		if ( modes.T[i].id == dlg->m_kbParams->kbPBE.m_encModeId )
			def = i;

		ComboBox_InsertStringT( hCmb, i, dlg->LoadStringOnceT( modes.T[i].ids ) );
	}

	int err = ComboBox_SetCurSel( hCmb, def );
	
	dlg->m_kbParams->kbPBE.m_encModeId = modes.T[def].id;
}

bool cPagePBE::InitV()
{
	m_MenuHelpIDs = (DWORD*)MenuHelpIDsT;

	m_edtA.Attach( GetDlgItem( m_hDlg, IDC_pwdPBEA ) );
	m_edtB.Attach( GetDlgItem( m_hDlg, IDC_pwdPBEB ) );

//	SetFocus( m_edtA.m_hEdit );

	if ( !m_useSecureTyping )
	{
		ShowWindow( GetDlgItem(m_hDlg, IDC_linePBEA), SW_HIDE );
		ShowWindow( GetDlgItem(m_hDlg, IDC_linePBEB), SW_HIDE );
	}

	int i, def;

	HWND hCmb = GetDlgItem( m_hDlg, IDC_cmbPBE_EncAlg );

	if ( hCmb == NULL ) // It is not advanced dialog
		return true;

	cEnumAlgIDs algs;

	cSymAlgorithm cAlg;

	for ( i = 0, def = 0; i<algs.Q; i++ )
	{
		cAlg.Init( algs.T[i], modes.T[0].id );

		ComboBox_InsertString( hCmb, i, cAlg.m_dispName );

		if ( m_dlg->m_kbParams->kbPBE.m_algId == algs.T[i] )
			def = i;
	}

	ComboBox_SetCurSel( hCmb, def );
	EnableWindow( hCmb, m_dlg->m_kbParams->m_allowChangeAlgorithms );

	hCmb = GetDlgItem( m_hDlg, IDC_cmbPBE_EncMode );
	
	//for ( i = 0, def = 0; i < modes.Q; i++ )
	//{
	//	if ( modes.T[i].id == m_dlg->m_kbParams->kbPBE.m_encModeId )
	//		def = i;
	//	ComboBox_InsertStringT( hCmb, i, m_dlg->LoadStringOnceT( modes.T[i].ids ) );
	//}

	//ComboBox_SetCurSel( hCmb, def );

	updateModesCmb( hCmb, algs.T[def], m_dlg );

	EnableWindow( hCmb, m_dlg->m_kbParams->m_allowChangeAlgorithms );

	hCmb = GetDlgItem( m_hDlg, IDC_cmbPBE_HashAlg );

	cEnumHashAlgIDs hashAlgs;
	for ( i = 0, def = 0; i<hashAlgs.Q; i++ )
	{
		ComboBox_InsertString( hCmb, i, ha_getHashAlgName( (BYTE)hashAlgs.T[i] ) );
		if ( m_dlg->m_kbParams->kbPBE.m_hashAlgId == hashAlgs.T[i] )
			def = i;
	}

	ComboBox_SetCurSel( hCmb, def );
	EnableWindow( hCmb, m_dlg->m_kbParams->m_allowChangeAlgorithms );

	return true;
}

void cPagePBE::Destroy()
{
	m_edtA.Detach();
	m_edtB.Detach();
}

bool cPagePBE::OnCommand( WPARAM wParam )
{
	// Set the default push button to "OK" when the user enters text 
	if( HIWORD (wParam) == EN_CHANGE ) 
	{
		SendMessage( m_hDlg, DM_SETDEFID, (WPARAM) IDOK, (LPARAM) 0);
		EnableWindow( GetDlgItem( m_hDlg, IDOK ), true );
	}

	if ( HIWORD (wParam) == CBN_SELCHANGE ) 
	{
		if ( LOWORD( wParam ) == IDC_cmbPBE_EncAlg )
		{
			HWND hCmb = GetDlgItem( m_hDlg, LOWORD( wParam ) );
			char name[ 128 ];
			ComboBox_GetText( hCmb, name, maxLen( name ) );

			cEnumAlgIDs algIds;
			int id = algIds.getAlgId( name );

			if ( id == -1 )
			{
				assert( false );
				return false;
			}

			m_dlg->m_kbParams->kbPBE.m_algId = id;
			m_dlg->m_kbParams->kbSSS.m_algId = id;

			hCmb = GetDlgItem( m_hDlg, IDC_cmbPBE_EncMode );

			updateModesCmb( hCmb, id, m_dlg );

			return true;
		}
		else
		if ( LOWORD( wParam ) == IDC_cmbPBE_EncMode )
		{
			HWND hCmb = GetDlgItem( m_hDlg, LOWORD( wParam ) );
			wchar_t name[ 128 ];
			GetWindowTextT( hCmb, name, maxLen( name ) );

			cEnumEncModes modeIds;
			int id = modeIds.getAlgId( name, m_dlg->m_hInst );

			if ( id == -1 )
			{
				assert( false );
				return false;
			}

			m_dlg->m_kbParams->kbPBE.m_encModeId = id;
			m_dlg->m_kbParams->kbSSS.m_encModeId = id;
			return true;
		}
		else
		if ( LOWORD( wParam ) == IDC_cmbPBE_HashAlg )
		{
			HWND hCmb = GetDlgItem( m_hDlg, LOWORD( wParam ) );
			char name[ 128 ];
			ComboBox_GetText( hCmb, name, maxLen( name ) );

			cEnumHashAlgIDs hashAlgIds;
			int id = hashAlgIds.getAlgId( name );

			if ( id == -1 )
			{
				assert( false );
				return false;
			}

			m_dlg->m_kbParams->kbPBE.m_hashAlgId = id;
			m_dlg->m_kbParams->kbSSS.m_hashAlgId = id;
			return true;
		}
	}

	switch(wParam) 
	{ 
		case IDOK: 
		{
			if ( cKbdEdit::CheckAndGetPassword( &(m_dlg->m_kbParams->kbPBE.m_pwd ), &m_edtA, &m_edtB ) )
				EndDialog( m_hDlg, ERROR_NO );
			return true;
		}
		default:
			return 0; 
	} 
}

//
//	End of PBE functions
//
//////////////////////////
