#include "cDlgKBParams.h"
#include "resource.h" 
#include <windowsx.h>
//#include "HELP\HelpIds.h"
#include "cDlgTabView.h"
#include "..\..\CertificateLib\SMemory\SBlocks.h"

////////////////////////////
//
//	SSS Functions 
//

static int SSS_ItemTab[] = {
	IDC_stSSS2,
	IDC_stSSS3,
	IDC_stSSS4,
	IDC_stSSS5,
	IDC_stSSS6,
	IDC_grpNewShare,
	IDC_spRequiredShares,
	IDC_edtRequiredShares,
	IDC_edtSharesReady,
	IDC_spCurrentUserShares,
	IDC_edtCurrentUserShares,
	IDC_pwdSSSA,
	IDC_lineSSSA,
	IDC_pwdSSSB,
	IDC_lineSSSB,
	IDC_btnReset,
	IDC_btnViewShares,
	IDC_btnAddNew
};

static int MenuHelpIDsT[] = {
	IDC_cmbType,				IDH_KeyBlockTypesSSS,
	IDC_grpType,				IDH_KeyBlockTypesSSS,
	IDC_edtRequiredShares,		IDH_RequiredShares,
	IDC_stSSS2,					IDH_RequiredShares,
	IDC_spRequiredShares,		IDH_RequiredShares,
	IDC_edtSharesReady,			IDH_SharesReady,
	IDC_stSSS3,					IDH_SharesReady,
	IDC_grpNewShare,			IDH_grpNewShare,
	IDC_edtCurrentUserShares,	IDH_CurrentUserShares,
	IDC_stSSS4,					IDH_CurrentUserShares,
	IDC_spCurrentUserShares,	IDH_CurrentUserShares,
	IDC_pwdSSSA,				IDH_Password,
	IDC_stSSS5,					IDH_Password,
	IDC_lineSSSA,				IDH_KBD_Line,
	IDC_pwdSSSB,				IDH_PasswordConfirm,
	IDC_stSSS6,					IDH_PasswordConfirm,
	IDC_lineSSSB,				IDH_KBD_Line,
	IDC_btnReset,				IDH_ResetShares,
	IDC_btnAddNew,				IDH_AddNewHoder,
	0,0
};

void cPageSSS::ShowItems( bool show )
{
	for ( int i = 0; i < sizeof( SSS_ItemTab )/sizeof( int ); i++ )
	{
		ShowWindow( GetDlgItem( m_hDlg, SSS_ItemTab[i] ), show ? SW_SHOW : SW_HIDE );
	}

	if ( !m_useSecureTyping )
	{
		ShowWindow( GetDlgItem( m_hDlg, IDC_lineSSSA ), SW_HIDE );
		ShowWindow( GetDlgItem( m_hDlg, IDC_lineSSSB ), SW_HIDE );
	}

	if ( show )
	{
		bool requiredSharesReady = m_dlg->m_kbParams->kbSSS.isReady(); 
		EnableWindow( GetDlgItem( m_hDlg, IDOK ), requiredSharesReady );
	}
}

//const int maxTotalShares = 5;

int cPageSSS::Notify( NMHDR *phdr )
{
	switch( phdr->code )
	{
		case UDN_DELTAPOS:
		{
			NMUPDOWN *p = (NMUPDOWN *)phdr;

			if ( phdr->idFrom == IDC_spCurrentUserShares )
			{
				if ( p->iPos + p->iDelta > m_dlg->m_kbParams->kbSSS.getMaxSharesQ() - m_dlg->m_kbParams->kbSSS.getTotalSharesQ() )
					return -1;

				PostMessage( m_hDlg, WM_userUpdateRanges, 0, 0 );
			}

			break;
		}
//		case NM_RELEASEDCAPTURE:
//		{
//			break;
//		}
		default:
			break;
	}

	return 0;
}

void cPageSSS::UpdateRange( int id, int min, int pos, bool init )
{
	if ( m_dlg == NULL )
		return;

	if ( !init && ( m_dlg->Spin_GetPos( id ) > pos ) )
		m_dlg->Spin_SetPos( id, pos );

	m_dlg->Spin_SetRange( id, min, pos );
	if ( init )
		m_dlg->Spin_SetPos( id, min );
}

void cPageSSS::UpdateRanges( bool init )
{
	if ( m_dlg == NULL )
		return;

	int pos = m_dlg->m_kbParams->kbSSS.getMaxSharesQ(); // Spin_GetPos( IDC_spTotalShares );

	UpdateRange( IDC_spRequiredShares, 2, pos, init );
	UpdateRange( IDC_spCurrentUserShares, 1, pos, init );
}

bool cPageSSS::InitV()
{
	m_MenuHelpIDs = (DWORD*)MenuHelpIDsT;

	if ( m_dlg == NULL )
		return false;

	m_hWndSave = m_dlg->m_kbParams->kbSSS.hWnd;
	m_dlg->m_kbParams->kbSSS.hWnd = m_hDlg;

	bool requiredSharesReady = m_dlg->m_kbParams->kbSSS.isReady(); 
	EnableWindow( GetDlgItem( m_hDlg, IDOK ), requiredSharesReady );

	int readyQ = m_dlg->m_kbParams->kbSSS.getTotalSharesQ();
	EnableWindow( GetDlgItem( m_hDlg, IDC_btnReset ), readyQ > 0 );
	EnableWindow( GetDlgItem( m_hDlg, IDC_btnViewShares ), readyQ > 0 );

//	Spin_SetRange( IDC_spTotalShares, 1 );
//	Spin_SetPos( IDC_spTotalShares, 2 );

	UpdateRanges( true );

	m_edtA.Attach( GetDlgItem( m_hDlg, IDC_pwdSSSA ) );
	m_edtB.Attach( GetDlgItem( m_hDlg, IDC_pwdSSSB ) );

	if ( !m_useSecureTyping )
	{
		ShowWindow( GetDlgItem(m_hDlg, IDC_lineSSSA), SW_HIDE );
		ShowWindow( GetDlgItem(m_hDlg, IDC_lineSSSB), SW_HIDE );
	}

	return true;
}

void cPageSSS::Destroy()
{
	if ( m_dlg == NULL )
		return;

	m_edtA.Detach();
	m_edtB.Detach();

	m_dlg->m_kbParams->kbSSS.hWnd = m_hWndSave;
}

bool cPageSSS::OnCommand( WPARAM wParam )
{
	switch(wParam) 
	{ 
		case IDC_btnAddNew:
		{
			return AddShare();
		}
		case IDC_btnViewShares:
		{
			return ViewShares();
		}
		case IDC_btnReset:
		{
			return ResetAll();
		}
		case IDOK: 
		{
			if ( m_dlg->m_kbParams->kbSSS.isReady() )
			{
				EndDialog( m_hDlg, ERROR_NO );
				return true;
			}
		}
		default:
			return 0; 
	} 

	return false;
}

bool cPageSSS::AddShare()
{
	BOOL translated = FALSE;

	int numberOfShares = GetDlgItemInt( m_hDlg, IDC_edtCurrentUserShares, &translated, false );

	if ( !translated )
	{
		m_dlg->DlgMessageBoxT( IDS_InvalidShareNumber, MB_ICONSTOP );
		SetFocus( GetDlgItem( m_hDlg, IDC_edtCurrentUserShares ) );
		return false;
	}

	cPassword pwd;

	if ( !cKbdEdit::CheckAndGetPassword( &pwd, &m_edtA, &m_edtB ) )
		return false;

	//
	//	Checks if current data block already has same password.
	//
	if ( FindSamePassword( m_dlg->m_kbParams->dataBlock, m_dlg->m_kbParams->dataBlockSize, &pwd, NULL, &(m_dlg->m_kbParams->kbSSS) ) )
	{
		m_dlg->DlgMessageBoxT( IDS_PASSWORD_IN_USE, MB_ICONEXCLAMATION );
		SetFocus( m_edtA.m_hEdit );
		return false;
	}

	//
	//	Checks if current scheme already has same password.
	//
	if ( !m_dlg->m_kbParams->kbSSS.checkPwdIsDifferent( &pwd ) )
	{
		m_dlg->DlgMessageBoxT( IDS_PASSWORD_IN_USE, MB_ICONEXCLAMATION ); // IDS_SamePwdWasShared
		SetFocus( m_edtA.m_hEdit );
		return false;
	}

	if ( !m_dlg->m_kbParams->kbSSS.addShare( numberOfShares, &pwd ) )
	{
		m_dlg->DlgMessageBoxT( IDS_ErrInAddingShare, MB_ICONSTOP );
		return false;
	}
	
	m_dlg->m_kbParams->kbSSS.reqQ = GetDlgItemInt( m_hDlg, IDC_edtRequiredShares, NULL, false );

	m_edtA.Empty();
	m_edtB.Empty();

	int readyQ = 0;
	bool requiredSharesReady = m_dlg->m_kbParams->kbSSS.isReady( &readyQ ); 

	EnableWindow( GetDlgItem( m_hDlg, IDOK ), requiredSharesReady );
	SetDlgItemInt( m_hDlg, IDC_edtSharesReady, readyQ, false );

	EnableWindow( GetDlgItem( m_hDlg, IDC_btnReset ), readyQ > 0 );
	EnableWindow( GetDlgItem( m_hDlg, IDC_btnViewShares ), readyQ > 0 );

	return true;
}

bool cPageSSS::ResetAll()
{
	bool ok = m_dlg->m_kbParams->kbSSS.resetAll();

	int readyQ = m_dlg->m_kbParams->kbSSS.getTotalSharesQ();
	EnableWindow( GetDlgItem( m_hDlg, IDC_btnReset ), readyQ > 0 );
	EnableWindow( GetDlgItem( m_hDlg, IDC_btnViewShares ), readyQ > 0 );
	SetDlgItemInt( m_hDlg, IDC_edtSharesReady, readyQ, false );

	return ok;
}

bool cPageSSS::ViewShares()
{
	cPlainTextBlock ptb;
	wchar_t text[ 256 ];
	wcsncpy( text, L"Number\tQuantity\n", maxLen( text ) );
	ptb.WriteString( text, false );

//	FormatT( text, maxLen( text ), L"%s\n \n", m_dlg->LoadStringOnceT( IDS_SharesReady ) );
//	ptb.WriteString( text, false );

	for( int i = 0; i < m_dlg->m_kbParams->kbSSS.itemQ; i++ )
	{
		FormatT( text, maxLen( text ), L"%s %d\t%d\n", m_dlg->LoadStringOnceT( IDS_szUser ), (i + 1), (m_dlg->m_kbParams->kbSSS.itemT[i].numberOfShares) );
		ptb.WriteString( text, false );
	}

	ptb.WriteString( L" \n", false );

	FormatT( text, maxLen( text ), L"%s\t%d\n", m_dlg->LoadStringOnceT( IDS_Total ), (m_dlg->m_kbParams->kbSSS.getTotalSharesQ()) );
	ptb.WriteString( text, false );

	ptb.WriteString( L" \n", false );
	FormatT( text, maxLen( text ), L"%s\t%d\n", m_dlg->LoadStringOnceT( IDS_SharesRequired ), (m_dlg->m_kbParams->kbSSS.reqQ) );
	ptb.WriteString( text, false );

	ptb.WriteString( L"", true );

	cDlgTabView dlg( IDC_ListView, (const wchar_t *)ptb.buffer ); // , caption, IDR_MAINFRAME );
	dlg.DoModal( m_dlg->m_hInst, IDD_SizedListView, m_dlg->m_hDlg );

	return true;
}

//
//	End of SSS functions
//
//////////////////////////
