////////////////////////////////////////////////////////////////////////////////////
//
//	Copyright (c) 2004 Jetico, Inc., Finland
//	All rights reserved.
//
//	File: kbdEdit.h
//	Revision: 
//	Created:
//	Description: 
//		Edit box sub class, it work with key board filter functions ( see kbd.h )
//
////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <windows.h>
#include "..\..\COMM_DEF\kbd.h"

class cDlgKBParams;
class cPassword;

#define BUFFER_SIZE 1024

class cKbdEdit
{
public:
#ifdef _DEBUG
	enum { sidData = 0xBC2007 };
	DWORD m_sig;
#endif

	wchar_t m_buffer[ BUFFER_SIZE ];
	HWND m_hEdit;
	LONG_PTR m_origWndProc;

	cDlgKBParams *dlg;
	kbdParams *kbd;

	void ClearBuff()
	{
		Empty();
		m_origWndProc = NULL;
	}

	void Empty()
	{
		memset( m_buffer, 0, sizeof( m_buffer ) );
		SetWindowText( m_hEdit, "" );
	}

	cKbdEdit()
	{
#ifdef _DEBUG
		m_sig = sidData;
#endif

		m_hEdit = NULL;
		ClearBuff();
	}

	~cKbdEdit()
	{
		ClearBuff();
	}

	bool Attach( HWND hEdit );
	void Detach();
//	void InsertCharToBuffer( wchar_t Letter, bool IsLetter = true );
	void InsertCharToBuffer( char Letter, bool IsLetter = true );

	static LRESULT APIENTRY editProc( HWND hEdit, UINT uMsg, WPARAM wParam, LPARAM lParam )
	{
		cKbdEdit *edit = (cKbdEdit *)(LPARAM)GetWindowLongPtrT( hEdit, GWLP_USERDATA );
		if ( edit == NULL )
		{
			assert( false );
			return false;
		}

		return edit->realEditProc( uMsg, wParam, lParam );
	}

	virtual LRESULT realEditProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	static bool CheckAndGetPassword( cPassword *pwd, cKbdEdit *edtA, cKbdEdit *edtB, bool silent = false );
	static bool CheckAndGetPassword( cPassword *pwd, cKbdEdit *edt, bool silent = false );
};