#include "module.h"
#include "container.h"

#include <mod/manager.h>
#include <common/log.h>
#include <common/core.h>

using namespace bdk;
using namespace kgghost;


bool V8Module::on_load()
{
	m_my_factory = NOTHROW_NEW V8Factory;
	if( !m_my_factory )
	{
		bc_get_log(BC_MSG_CRIT) << "V8 Error: no memory to create container factory\n";
		return false;
	}


	std::string product(this->name());
	BC_DEBUG_PRINT(("Registering container type %s\n", product.c_str()));

	bc_core()->container_manager()->register_type(std::string(this->name()), m_my_factory, true);
	return true;
}


bool V8Module::on_release()
{
	bc_core()->container_manager()->unregister_type(std::string(this->name()));
	delete m_my_factory;
	return true;
}


const char* V8Module::name() const
{
	return "BCv8";
}


bc_mod_id_t V8Module::id() const
{
	return 0xbc08;
}


const char* V8Module::description() const
{
	return "BC Container Format V8 (KG-GHOST keygen)";
}


BC_EXPORT_MODULE(V8Module)

