#include "range.h"

using namespace kgghost;

range_t::range_t() :
	m_base(0),
	m_total(0)
{
}


range_t::range_t(unsigned int base, unsigned int total):
	m_base(base),
	m_total(total)
{
}


unsigned int range_t::size() const
{
	return m_total;
}


unsigned int range_t::base() const
{
	return m_base;
}


bool range_t::is_empty() const
{
	return (this->size() == 0);
}


range_t range_t::subrange(unsigned int local_first, unsigned int length)
{
	if( (local_first + length) > this->size() ) 
		return empty_range();

	return contigious_range(this->base() + local_first, length);
}


namespace kgghost
{


	range_t	contigious_range(unsigned int base, unsigned int length)
	{
		return range_t(base, length);
	}


	range_t	empty_range()
	{
		return range_t();
	}


	range_t	sparse_range(const unsigned int* table, unsigned int size)
	{
		return empty_range(); // stub
	}


	bool range_fits(const range_t& range, unsigned int limit)
	{
		return (range.size() + range.base()) <= limit;
	}
}

/*
keyblock_range_t keyblock_range_t::next_occupied()
{
	for(unsigned int i = 0; i < this->size(); ++i)
	{
		if(this->get_keyblock(i)->type() != (WORD)KB_TYPE_EMPTY) 
			return this->subrange(i, this->size() - i);
	}

	return empty_keyblock_range();
}


keyblock_range_t keyblock_range_t::next_vacant()
{
	for(unsigned int i = 0; i < this->size(); ++i)
	{
		if(this->get_keyblock(i)->type() == (WORD)KB_TYPE_EMPTY) 
			return this->subrange(i, this->size() - i);
	}

	return empty_keyblock_range();
}


keyblock_range_t keyblock_range_t::find_vacant_subrange( unsigned int required_size )
{
	// check that we have anough space to satisfy request
	if( required_size > this->size() ) return empty_keyblock_range();

	keyblock_range_t next_occupied;
	keyblock_range_t next_vacant = this->next_vacant(); // skip first occupied blocks
	keyblock_range_t res = empty_keyblock_range();

	while(!next_vacant.is_empty())
	{
		// get a subrange starting from next vacant element with required length
		res = next_vacant.subrange(0, required_size);

		if( res.is_empty() || res.is_vacant() ) break;

		// skip vacant blocks that were not enough to satisfy
		next_occupied = next_vacant.next_occupied();

		// set new next vacant position after skipped blocks
		next_vacant = next_occupied.next_vacant();
	}	

	return res;
}


keyblock_range_t keyblock_range_t::find_biggest_vacant_subrange()
{
	keyblock_range_t next_vacant = this->next_vacant(); // skip first occupied blocks
	keyblock_range_t next_occupied;
	keyblock_range_t max = empty_keyblock_range();

	unsigned int size = 0;

	while(!next_vacant.is_empty())
	{
		// skip to the next occupied block after vacant
		next_occupied = next_vacant.next_occupied();
				
		// get the number of blocks skipped as vacant
		size = next_vacant.size() - next_occupied.size();

		// compare with current maximum
		if( size > max.size() ) {
			max = next_vacant.subrange(0, size);
		}

		// skip to next vacant block
		next_vacant = next_occupied.next_vacant();
	}

	return max;
}
*/
