/*
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 */

#ifndef BDK_COMMON_DIRECTORY_H
#define BDK_COMMON_DIRECTORY_H

#include <vector>
#include <common/fs.h>

namespace bdk
{
        /**
         * @brief       Filesystem directory abstraction
         */
        class BCDirectory
        {
        public:

                /**
                 * @brief       Create directory object from path
                 */
                explicit BCDirectory(std::string const & path) :
                        m_path(path)
                {}


                /**
                 * @brief       Create directory object from static fs object
                 */
                explicit BCDirectory(BCFSObject const & fsobj) :
                        m_path(fsobj.path())
                {}


                /**
                 * @brief       Get directory listing
                 */
                void list(std::vector<std::string> & listing) const;

        private:

                /* directory path */
                std::string m_path;
        };
}

#endif
