/**
 *
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	file: singleton.h
 *	scope: core\common
 *	author: evgeny yakovlev
 *
 *	description: 
 *	Single-instance objects template mixin.
 *
 */

#ifndef BDK_COMMON_SINGLETON_H
#define BDK_COMMON_SINGLETON_H

#include <common/build.h>

namespace bdk
{


  	/** 
	 * @brief	Template class for creating single-instance global classes.
    	 */
    	template < typename T > 
	class CBCSingleton
    	{
	public:


        	static T& instance()
		{	
			static T instance;
			return &instance; 
		}


        	static T* p_instance()
		{ 
			return &instance(); 
		}


    	protected:


        	CBCSingleton()
        	{
        	}


	        ~CBCSingleton()
	        {  
		}


    	protected:

    	};
}



#endif
