/*
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 */

#ifndef BDK_COMMON_THREAD_H
#define BDK_COMMON_THREAD_H

#include <common/class_defs.h>
#include <backend/sync.h>

namespace bdk
{

        /**
         * @brief       Thread entry functor.
         */
        class IBCThreadFunction
        {
                BC_INTERFACE(IBCThreadFunction)
        public:
                virtual void operator () () = 0;
        };


        /**
         * @brief       Thread object.
         */
        class BCThread
        {
                BC_FORBID_COPY(BCThread)

        public:

                BCThread();

                ~BCThread();

                void start(IBCThreadFunction* f);

        protected:

                static void* thread_entry(void* f);

        private:

                backend::bc_thread_handle_t m_systhread;

        };
}

#endif /* BDK_COMMON_THREAD_H */

