
#ifndef BCCORE_TYPES_H
#define BCCORE_TYPES_H

#include <stdlib.h>

/* BestCrypt size-sensitive types */
typedef char		bc8_t;
typedef unsigned char	bcu8_t;
typedef short		bc16_t;
typedef unsigned short	bcu16_t;
typedef int		bc32_t;
typedef unsigned int	bcu32_t;
typedef long long int	bc64_t;
typedef unsigned long long int	bcu64_t;

typedef bcu8_t		bc_byte_t;
typedef bc16_t		bc_word_t;
typedef bc32_t		bc_dword_t;
typedef bc64_t		bc_long_t;
typedef bcu16_t		bc_uword_t;
typedef bcu32_t		bc_udword_t;
typedef bcu64_t		bc_ulong_t;

/* BestCrypt specific types */
typedef unsigned int	bc_key_handle_t;
typedef unsigned int	alg_id_t;
typedef bcu32_t		bc_alg_id_t;
typedef bcu32_t		bc_alg_mode_id_t;
typedef bcu32_t		bc_mod_id_t;
typedef bcu32_t		bc_fs_id_t;
typedef bc_ulong_t	bc_size_t;


/* space unit */
struct bc_space_unit_t
{
	bc_ulong_t	offset;
	bc_ulong_t	length;
};


/**
 * @brief	Sector data
 */
struct bc_sector_t
{
	bc_byte_t	sec_data[512];
};


/**
 * @brief	Sector initial vector
 */
union bc_sector_iv_t
{
	bcu64_t 	iv;
	bcu16_t 	word_iv[4];
};


#endif
