#include <common/command.h>

using namespace bdk;

void BCCommandManager::register_command( std::string const & name, BCCommandImpl* implementor )
{
	commands_iter_t i = _find_command_iter(name);
	
	if( i != m_commands.end() )
	{
		return;
	}
	else
	{
		bc_command_entry_t c;
		c.cmd_name = name;
		c.cmd_impl = implementor;

		m_commands.push_back(c);
	}
}


void BCCommandManager::unregister_command(std::string const & name)
{
	commands_iter_t i = _find_command_iter(name);
	
	if( i != m_commands.end() )
	{
		m_commands.erase(i);
	}
}


bool find_command(std::string const & name)
{
	commands_iter_t i = _find_command_iter(name);
	if(i != m_commands.end() )
		return true;


	return false;
}


commands_iter_t BCCommandManager::_find_command_iter(std::string const & name)
{
	commands_iter_t i = m_commands.begin();
	commands_iter_t end = m_commands.end();

	while(i != end)
	{
		if(i->cmd_name == name)
			break;
		++i;
	}

	return i;
}

