/**
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 */

#include <common/fs.h>
#include <common/log.h>
#include <common/exception.h>

#include <backend/fs.h>

using namespace bdk;

namespace bdk
{
	std::ostream& operator << (std::ostream & stream, BCFSObject const & fsobj)
	{
		stream << fsobj.path();
		return stream;
	}
}


bc_file_type_t BCFSObject::type() const
{
	return backend::bc_file_type(m_path.c_str());
}


void BCFSObject::canonize()
{
	backend::bc_file_canonize_path(m_path);
}


bool BCFSObject::access(bcu32_t mode) const
{
	return backend::bc_file_touch(m_path.c_str(), mode);
}


bool BCFSObject::is_owner() const
{
	return backend::bc_file_is_owner(m_path.c_str());
}


void BCFSObject::remove() const
{
	backend::bc_file_remove(m_path.c_str());
}



