#include <common/log.h>
#include <common/exception.h>
#include <common/build.h>

#include <stdio.h>
#include <stdarg.h>


using namespace bdk;

 
BCLog::~BCLog() throw()
{
	m_listeners.clear();
}


void BCLog::put(std::string const & str, bc_msg_level lvl)
{
	log_listeners_iter i = m_listeners.begin();
	log_listeners_iter end = m_listeners.end();

	while(i != end)
	{
		(*i)->log_message(str, lvl);
		++i;
	}
}


void BCLog::register_listener(BCLogListener* listener)
{
	m_listeners.push_back(listener);
}


void BCLog::unregister_listener(BCLogListener* listener)
{
	m_listeners.remove(listener);
}


namespace bdk
{
	BCLog& bc_get_log()
	{
		static BCLog the_default_log;
		return the_default_log;
	}

	BCLog::BCMessageStream bc_get_log(bc_msg_level lvl)
	{
		return bc_get_log().msg(lvl);
	}
}
