/*
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 */

#include <common/thread.h>
#include <common/build.h>

       #include <unistd.h>
       #include <sys/syscall.h>   /* For SYS_xxx definitions */

using namespace bdk;

BCThread::BCThread()
{
        m_systhread = backend::bc_thread_get();
}

BCThread::~BCThread()
{
        try
        {
                backend::bc_thread_put(m_systhread);
        }
        catch(...)
        {
        }
}

void BCThread::start(IBCThreadFunction* f)
{
        backend::bc_thread_start(m_systhread, BCThread::thread_entry, f);
}

void* BCThread::thread_entry(void* f)
{
        IBCThreadFunction* functor = static_cast<IBCThreadFunction*>(f);
        BC_DEBUG_PRINT(("Debug: starting new thread id %d\\%d\n", getpid(), syscall(SYS_gettid)));
        functor->operator()();
        return NULL;
}
