/*
 *	Copyright (c) 2009 Jetico, Inc., Finland
 *	All rights reserved.
 *
 *	Core platform algorithms to link, mount, check and format bestcrypt volumes.
 *	These algorithms do not work with containers - they work with volumes encoded inside containers.
 *	To decode a volume from container, user corresponding interfaces and the call these.
 */

#ifndef BC_CORE_H
#define BC_CORE_H


namespace bestcrypt {


	typedef enum 
	{
		kBCCore_Success = 0,
		kBCCore_NoFreeDevice,
	};


	/**
	 * Link volume to virtual block device driver.
	 *
	 * @p volume	Volume info to link. On success, initializes the linked device field.
	 * @p ro	Flag to link in read-only mode.
	 */
	int bc_link_volume(bc_volume_info* volume, bool ro);


	/**
	 * Unlink previously linked volume from device.
	 *
	 * @p volume	Volume to unlink. 
	 */
	void bc_unlink_volume(bc_volume_info* volume);


}


#endif

