#ifndef BC_LINUX_PROCESS_H
#define BC_LINUX_PROCESS_H

#include <string>
#include <vector>

class Process
{
public:


	/**
	 * @brief	Init process
	 */
	Process(std::string const & objname) : m_name(objname)
	{
	}


	/**
	 * @brief	Execute process.
	 *
	 * @p args	Argument list.
	 *
	 * @return	System return code.
	 */
	int exec(const std::vector < std::string > & args);


	/**
	 * Execute process and capture its output by redirecting stdout.
	 * @args	Argument list.
	 * @output	Output buffer.
	 * @return	Process return code.
	 */
	int exec(const std::vector < std::string > & args, std::string& output);

private:


	std::string m_name;
};


#endif
